unit VCFrmla1;

{ Conversion log:
  Property TVCFormulaOne.Type renamed to Type_: Identifier is a reserved word }

interface

uses Ole2, OleCtl, Classes, Graphics, OleCtrls;

const

{ F1ColWidthUnitsConstants }

  F1ColWidthUnitsCharacters = 0;
  F1ColWidthUnitsTwips = 1;

{ F1MousePointerConstants }

  F1Default = 0;
  F1Arrow = 1;
  F1Cross = 2;
  F1IBeam = 3;
  F1Icon = 4;
  F1Size = 5;
  F1SizeNESW = 6;
  F1SizeNS = 7;
  F1SizeNWSE = 8;
  F1SizeWE = 9;
  F1UpArrow = 10;
  F1Hourglass = 11;
  F1NoDrop = 12;
  F1Custom = 13;

{ F1ShowOffOnAutoConstants }

  F1Off = 0;
  F1On = 1;
  F1Auto = 2;

{ F1ShowTabsConstants }

  F1TabsOff = 0;
  F1TabsBottom = 1;
  F1TabsTop = 2;

{ F1ModeConstants }

  F1ModeNormal = 0;
  F1ModeLine = 1;
  F1ModeRectangle = 2;
  F1ModeOval = 3;
  F1ModeArc = 4;
  F1ModeChart = 5;
  F1ModeField = 6;
  F1ModeButton = 7;
  F1ModePolygon = 8;
  F1ModeCheckBox = 9;
  F1ModeDropDown = 10;

{ F1PolyEditModeConstants }

  F1PolyEditModeNormal = 0;
  F1PolyEditModePoints = 1;

{ F1ShiftTypeConstants }

  F1ShiftHorizontal = 1;
  F1ShiftVertical = 2;
  F1ShiftRows = 3;
  F1ShiftCols = 4;

{ F1HAlignConstants }

  F1HAlignGeneral = 1;
  F1HAlignLeft = 2;
  F1HAlignCenter = 3;
  F1HAlignRight = 4;
  F1HAlignFill = 5;
  F1HAlignJustify = 6;
  F1HAlignCenterAcrossCells = 7;

{ F1VAlignConstants }

  F1VAlignTop = 1;
  F1VAlignCenter = 2;
  F1VAlignBottom = 3;

{ F1ClearTypeConstants }

  F1ClearDlg = 0;
  F1ClearAll = 1;
  F1ClearFormats = 2;
  F1ClearValues = 3;

{ F1FileTypeConstants }

  F1FileFormulaOne = 1;
  F1FileExcel4 = 2;
  F1FileTabbedText = 3;
  F1FileExcel5 = 4;
  F1FileFormulaOne3 = 5;
  F1FileTabbedTextValuesOnly = 6;

{ F1ObjTypeConstants }

  F1ObjLine = 1;
  F1ObjRectangle = 2;
  F1ObjOval = 3;
  F1ObjArc = 4;
  F1ObjChart = 5;
  F1ObjButton = 7;
  F1ObjPolygon = 8;
  F1ObjCheckBox = 9;
  F1ObjDropDown = 10;
  F1ObjPicture = 11;

{ F1ErrorConstants }

  F1ErrorNone = 0;
  F1ErrorGeneral = 20001;
  F1ErrorBadArgument = 20002;
  F1ErrorNoMemory = 20003;
  F1ErrorBadFormula = 20004;
  F1ErrorBufTooShort = 20005;
  F1ErrorNotFound = 20006;
  F1ErrorBadRC = 20007;
  F1ErrorBadHSS = 20008;
  F1ErrorTooManyHSS = 20009;
  F1ErrorNoTable = 20010;
  F1ErrorUnableToOpenFile = 20011;
  F1ErrorInvalidFile = 20012;
  F1ErrorInsertShiftOffTable = 20013;
  F1ErrorOnlyOneRange = 20014;
  F1ErrorNothingToPaste = 20015;
  F1ErrorBadNumberFormat = 20016;
  F1ErrorTooManyFonts = 20017;
  F1ErrorTooManySelectedRanges = 20018;
  F1ErrorUnableToWriteFile = 20019;
  F1ErrorNoTransaction = 20020;
  F1ErrorNothingToPrint = 20021;
  F1ErrorPrintMarginsDontFit = 20022;
  F1ErrorCancel = 20023;
  F1ErrorUnableToInitializePrinter = 20024;
  F1ErrorStringTooLong = 20025;
  F1ErrorFormulaTooLong = 20026;
  F1ErrorUnableToOpenClipboard = 20027;
  F1ErrorPasteWouldOverflowSheet = 20028;
  F1ErrorLockedCellsCannotBeModified = 20029;
  F1ErrorLockedDocCannotBeModified = 20030;
  F1ErrorInvalidName = 20031;
  F1ErrorCannotDeleteNameInUse = 20032;
  F1ErrorUnableToFindName = 20033;
  F1ErrorNoWindow = 20034;
  F1ErrorSelection = 20035;
  F1ErrorTooManyObjects = 20036;
  F1ErrorInvalidObjectType = 20037;
  F1ErrorObjectNotFound = 20038;
  F1ErrorInvalidRequest = 20039;
  F1ErrorBadValidationRule = 20040;
  F1ErrorBadInputMask = 20041;
  F1ErrorValidationFailed = 20042;
  F1ErrorNoODBCConnection = 20043;
  F1ErrorUnableToLoadODBC = 20044;
  F1ErrorUnsupportedFeature = 20045;

{ F1ControlCellConstants }

  F1ControlNoCell = 0;
  F1ControlCellValue = 1;
  F1ControlCellText = 2;

type

  TVCFormulaOneClick = procedure(Sender: TObject; nRow, nCol: Integer) of object;
  TVCFormulaOneDblClick = procedure(Sender: TObject; nRow, nCol: Integer) of object;
  TVCFormulaOneStartEdit = procedure(Sender: TObject; var EditString: string; var Cancel: Smallint) of object;
  TVCFormulaOneEndEdit = procedure(Sender: TObject; var EditString: string; var Cancel: Smallint) of object;
  TVCFormulaOneObjClick = procedure(Sender: TObject; var ObjName: string; ObjID: Integer) of object;
  TVCFormulaOneObjDblClick = procedure(Sender: TObject; var ObjName: string; ObjID: Integer) of object;
  TVCFormulaOneRClick = procedure(Sender: TObject; nRow, nCol: Integer) of object;
  TVCFormulaOneRDblClick = procedure(Sender: TObject; nRow, nCol: Integer) of object;
  TVCFormulaOneObjValueChanged = procedure(Sender: TObject; var ObjName: string; ObjID: Integer) of object;
  TVCFormulaOneObjGotFocus = procedure(Sender: TObject; var ObjName: string; ObjID: Integer) of object;
  TVCFormulaOneObjLostFocus = procedure(Sender: TObject; var ObjName: string; ObjID: Integer) of object;
  TVCFormulaOneValidationFailed = procedure(Sender: TObject; var pEntry: string; nSheet, nRow, nCol: Integer; var pShowMessage: string; var pAction: Smallint) of object;

  TVCFormulaOne = class(TOleControl)
  private
    FOnClick: TVCFormulaOneClick;
    FOnDblClick: TVCFormulaOneDblClick;
    FOnCancelEdit: TNotifyEvent;
    FOnSelChange: TNotifyEvent;
    FOnStartEdit: TVCFormulaOneStartEdit;
    FOnEndEdit: TVCFormulaOneEndEdit;
    FOnStartRecalc: TNotifyEvent;
    FOnEndRecalc: TNotifyEvent;
    FOnTopLeftChanged: TNotifyEvent;
    FOnObjClick: TVCFormulaOneObjClick;
    FOnObjDblClick: TVCFormulaOneObjDblClick;
    FOnRClick: TVCFormulaOneRClick;
    FOnRDblClick: TVCFormulaOneRDblClick;
    FOnObjValueChanged: TVCFormulaOneObjValueChanged;
    FOnModified: TNotifyEvent;
    FOnObjGotFocus: TVCFormulaOneObjGotFocus;
    FOnObjLostFocus: TVCFormulaOneObjLostFocus;
    FOnValidationFailed: TVCFormulaOneValidationFailed;
    function Get_ColText(nCol: Integer): string; stdcall;
    procedure Set_ColText(nCol: Integer; const Value: string); stdcall;
    function Get_DefinedName(const pName: string): string; stdcall;
    procedure Set_DefinedName(const pName: string; const Value: string); stdcall;
    function Get_EntryRC(nRow, nCol: Integer): string; stdcall;
    procedure Set_EntryRC(nRow, nCol: Integer; const Value: string); stdcall;
    function Get_FormattedTextRC(nRow, nCol: Integer): string; stdcall;
    procedure Set_FormattedTextRC(nRow, nCol: Integer; const Value: string); stdcall;
    function Get_FormulaRC(nRow, nCol: Integer): string; stdcall;
    procedure Set_FormulaRC(nRow, nCol: Integer; const Value: string); stdcall;
    function Get_LastColForRow(nRow: Integer): Integer; stdcall;
    procedure Set_LastColForRow(nRow: Integer; Value: Integer); stdcall;
    function Get_LogicalRC(nRow, nCol: Integer): TOleBool; stdcall;
    procedure Set_LogicalRC(nRow, nCol: Integer; Value: TOleBool); stdcall;
    function Get_NumberRC(nRow, nCol: Integer): Double; stdcall;
    procedure Set_NumberRC(nRow, nCol: Integer; Value: Double); stdcall;
    function Get_RowText(nRow: Integer): string; stdcall;
    procedure Set_RowText(nRow: Integer; const Value: string); stdcall;
    function Get_TextRC(nRow, nCol: Integer): string; stdcall;
    procedure Set_TextRC(nRow, nCol: Integer; const Value: string); stdcall;
    function Get_TypeRC(nRow, nCol: Integer): Smallint; stdcall;
    procedure Set_TypeRC(nRow, nCol: Integer; Value: Smallint); stdcall;
    function Get_ColWidth(nCol: Integer): Smallint; stdcall;
    procedure Set_ColWidth(nCol: Integer; Value: Smallint); stdcall;
    function Get_RowHeight(nRow: Integer): Smallint; stdcall;
    procedure Set_RowHeight(nRow: Integer; Value: Smallint); stdcall;
    function Get_DefinedNameByIndex(nName: Integer): string; stdcall;
    procedure Set_DefinedNameByIndex(nName: Integer; const Value: string); stdcall;
    function Get_SheetName(nSheet: Integer): string; stdcall;
    procedure Set_SheetName(nSheet: Integer; const Value: string); stdcall;
    function Get_PaletteEntry(nEntry: Integer): TColor; stdcall;
    procedure Set_PaletteEntry(nEntry: Integer; Value: TColor); stdcall;
    function Get_ColWidthTwips(Col: Integer): Smallint; stdcall;
    procedure Set_ColWidthTwips(Col: Integer; Value: Smallint); stdcall;
    function Get_ObjItem(ID: Integer; Item: Smallint): string; stdcall;
    procedure Set_ObjItem(ID: Integer; Item: Smallint; const Value: string); stdcall;
    function Get_ObjItems(ID: Integer): string; stdcall;
    procedure Set_ObjItems(ID: Integer; const Value: string); stdcall;
    function Get_ObjName(ID: Integer): string; stdcall;
    procedure Set_ObjName(ID: Integer; const Value: string); stdcall;
    function Get_ObjText(ID: Integer): string; stdcall;
    procedure Set_ObjText(ID: Integer; const Value: string); stdcall;
    function Get_ObjValue(ID: Integer): Smallint; stdcall;
    procedure Set_ObjValue(ID: Integer; Value: Smallint); stdcall;
    function Get_ObjVisible(ID: Integer): TOleBool; stdcall;
    procedure Set_ObjVisible(ID: Integer; Value: TOleBool); stdcall;
    function Get_AutoFillItems(Index: Smallint): string; stdcall;
    procedure Set_AutoFillItems(Index: Smallint; const Value: string); stdcall;
    function Get_ColHidden(nCol: Integer): TOleBool; stdcall;
    procedure Set_ColHidden(nCol: Integer; Value: TOleBool); stdcall;
    function Get_RowHidden(nRow: Integer): TOleBool; stdcall;
    procedure Set_RowHidden(nRow: Integer; Value: TOleBool); stdcall;
    function Get_SheetSelected(nSheet: Integer): TOleBool; stdcall;
    procedure Set_SheetSelected(nSheet: Integer; Value: TOleBool); stdcall;
  protected
    procedure InitControlData; override;
  public
    procedure EditPasteValues; stdcall;
    procedure GetAlignment(var pHorizontal: Smallint; var pWordWrap: TOleBool; var pVertical, pOrientation: Smallint); stdcall;
    procedure GetBorder(var pLeft, pRight, pTop, pBottom, pShade: Smallint; var pcrLeft, pcrRight, pcrTop, pcrBottom: TColor); stdcall;
    procedure GetFont(var pName: string; var pSize: Smallint; var pBold, pItalic, pUnderline, pStrikeout: TOleBool; var pcrColor: TColor; var pOutline, pShadow: TOleBool); stdcall;
    procedure GetLineStyle(var pStyle: Smallint; var pcrColor: TColor; var pWeight: Smallint); stdcall;
    procedure GetPattern(var pPattern: Smallint; var pcrFG, pcrBG: TColor); stdcall;
    procedure GetProtection(var pLocked, pHidden: TOleBool); stdcall;
    procedure GetTabbedText(nR1, nC1, nR2, nC2: Integer; bValuesOnly: TOleBool; var phText: Integer); stdcall;
    procedure SetTabbedText(nStartRow, nStartCol: Integer; var pRows, pCols: Integer; bValuesOnly: TOleBool; const pText: string); stdcall;
    procedure AddColPageBreak(nCol: Integer); stdcall;
    procedure AddPageBreak; stdcall;
    procedure AddRowPageBreak(nRow: Integer); stdcall;
    procedure AddSelection(nR1, nC1, nR2, nC2: Integer); stdcall;
    procedure Attach(const pTitle: string); stdcall;
    procedure AttachToSS(hSrcSS: Integer); stdcall;
    procedure CalculationDlg; stdcall;
    procedure CancelEdit; stdcall;
    procedure CheckRecalc; stdcall;
    procedure ClearClipboard; stdcall;
    procedure ClearRange(nR1, nC1, nR2, nC2: Integer; ClearType: Smallint); stdcall;
    procedure ColorPaletteDlg; stdcall;
    procedure ColWidthDlg; stdcall;
    procedure CopyAll(hSrcSS: Integer); stdcall;
    procedure CopyRange(nDstR1, nDstC1, nDstR2, nDstC2, hSrcSS, nSrcR1, nSrcC1, nSrcR2, nSrcC2: Integer); stdcall;
    procedure DefinedNameDlg; stdcall;
    procedure DeleteDefinedName(const pName: string); stdcall;
    procedure DeleteRange(nR1, nC1, nR2, nC2: Integer; ShiftType: Smallint); stdcall;
    procedure Draw(hDC, x, y, cx, cy, nRow, nCol: Integer; var pRows, pCols: Integer; nFixedRow, nFixedCol, nFixedRows, nFixedCols: Integer); stdcall;
    procedure EditClear(ClearType: Smallint); stdcall;
    procedure EditCopy; stdcall;
    procedure EditCopyDown; stdcall;
    procedure EditCopyRight; stdcall;
    procedure EditCut; stdcall;
    procedure EditDelete(ShiftType: Smallint); stdcall;
    procedure EditInsert(ShiftType: Smallint); stdcall;
    procedure EditPaste; stdcall;
    procedure EndEdit; stdcall;
    procedure FilePageSetupDlg; stdcall;
    procedure FilePrint(bShowPrintDlg: TOleBool); stdcall;
    procedure FilePrintSetupDlg; stdcall;
    procedure FormatAlignmentDlg; stdcall;
    procedure FormatBorderDlg; stdcall;
    procedure FormatCurrency0; stdcall;
    procedure FormatCurrency2; stdcall;
    procedure FormatDefaultFontDlg; stdcall;
    procedure FormatFixed; stdcall;
    procedure FormatFixed2; stdcall;
    procedure FormatFontDlg; stdcall;
    procedure FormatFraction; stdcall;
    procedure FormatGeneral; stdcall;
    procedure FormatHmmampm; stdcall;
    procedure FormatMdyy; stdcall;
    procedure FormatNumberDlg; stdcall;
    procedure FormatPatternDlg; stdcall;
    procedure FormatPercent; stdcall;
    procedure FormatScientific; stdcall;
    procedure GetActiveCell(var pRow, pCol: Integer); stdcall;
    procedure GetDefaultFont(var pBuf: string; var pSize: Smallint); stdcall;
    procedure GetHdrSelection(var pTopLeftHdr, pRowHdr, pColHdr: TOleBool); stdcall;
    procedure GetIteration(var pIteration: TOleBool; var pMaxIterations: Smallint; var pMaxChange: Double); stdcall;
    procedure GetPrintScale(var pScale: Smallint; var pFitToPage: TOleBool; var pVPages, pHPages: Integer); stdcall;
    procedure GetSelection(nSelection: Smallint; var pR1, pC1, pR2, pC2: Integer); stdcall;
    procedure GotoDlg; stdcall;
    procedure HeapMin; stdcall;
    procedure InitTable; stdcall;
    procedure InsertRange(nR1, nC1, nR2, nC2: Integer; ShiftType: Smallint); stdcall;
    procedure LineStyleDlg; stdcall;
    procedure MoveRange(nR1, nC1, nR2, nC2, nRowOffset, nColOffset: Integer); stdcall;
    procedure ObjAddItem(ID: Integer; const pItem: string); stdcall;
    procedure ObjAddSelection(ID: Integer); stdcall;
    procedure ObjBringToFront; stdcall;
    procedure ObjDeleteItem(ID: Integer; nItem: Smallint); stdcall;
    procedure ObjGetCell(ID: Integer; var pControlCellType: Smallint; var pRow, pCol: Integer); stdcall;
    procedure ObjGetPos(ID: Integer; var pX1, pY1, pX2, pY2: Single); stdcall;
    procedure ObjGetSelection(nSelection: Smallint; var pID: Integer); stdcall;
    procedure ObjInsertItem(ID: Integer; nItem: Smallint; const pItem: string); stdcall;
    procedure ObjNameDlg; stdcall;
    procedure ObjNew(ObjType: Smallint; nX1, nY1, nX2, nY2: Single; var pID: Integer); stdcall;
    procedure ObjNewPicture(nX1, nY1, nX2, nY2: Single; var pID: Integer; hMF, nMapMode, nWndExtentX, nWndExtentY: Integer); stdcall;
    procedure ObjOptionsDlg; stdcall;
    procedure ObjPosToTwips(nX1, nY1, nX2, nY2: Single; var pX, pY, pCX, pCY: Integer; var pShown: Smallint); stdcall;
    procedure ObjSendToBack; stdcall;
    procedure ObjSetCell(ID: Integer; ControlCellType: Smallint; nRow, nCol: Integer); stdcall;
    procedure ObjSetPicture(ID, hMF: Integer; nMapMode: Smallint; nWndExtentX, nWndExtentY: Integer); stdcall;
    procedure ObjSetPos(ID: Integer; nX1, nY1, nX2, nY2: Single); stdcall;
    procedure ObjSetSelection(ID: Integer); stdcall;
    procedure OpenFileDlg(const pTitle: string; hWndParent: Integer; var pBuf: string); stdcall;
    procedure ProtectionDlg; stdcall;
    procedure RangeToTwips(nRow1, nCol1, nRow2, nCol2: Integer; var pX, pY, pCX, pCY: Integer; var pShown: Smallint); stdcall;
    procedure Read(const pPathName: string; var pFileType: Smallint); stdcall;
    procedure ReadFromBlob(hBlob: Integer; nReservedBytes: Smallint); stdcall;
    procedure Recalc; stdcall;
    procedure RemoveColPageBreak(nCol: Integer); stdcall;
    procedure RemovePageBreak; stdcall;
    procedure RemoveRowPageBreak(nRow: Integer); stdcall;
    procedure RowHeightDlg; stdcall;
    procedure SaveFileDlg(const pTitle: string; var pBuf: string; var pFileType: Smallint); stdcall;
    procedure SaveWindowInfo; stdcall;
    procedure SetActiveCell(nRow, nCol: Integer); stdcall;
    procedure SetAlignment(HAlign: Smallint; bWordWrap: TOleBool; VAlign, nOrientation: Smallint); stdcall;
    procedure SetBorder(nOutline, nLeft, nRight, nTop, nBottom, nShade: Smallint; crOutline, crLeft, crRight, crTop, crBottom: TColor); stdcall;
    procedure SetColWidth(nC1, nC2: Integer; nWidth: Smallint; bDefColWidth: TOleBool); stdcall;
    procedure SetColWidthAuto(nR1, nC1, nR2, nC2: Integer; bSetDefaults: TOleBool); stdcall;
    procedure SetDefaultFont(const pName: string; nSize: Smallint); stdcall;
    procedure SetFont(const pName: string; nSize: Smallint; bBold, bItalic, bUnderline, bStrikeout: TOleBool; crColor: TColor; bOutline, bShadow: TOleBool); stdcall;
    procedure SetHdrSelection(bTopLeftHdr, bRowHdr, bColHdr: TOleBool); stdcall;
    procedure SetIteration(bIteration: TOleBool; nMaxIterations: Smallint; nMaxChange: Double); stdcall;
    procedure SetLineStyle(nStyle: Smallint; crColor: TColor; nWeight: Smallint); stdcall;
    procedure SetPattern(nPattern: Smallint; crFG, crBG: TColor); stdcall;
    procedure SetPrintAreaFromSelection; stdcall;
    procedure SetPrintScale(nScale: Smallint; bFitToPage: TOleBool; nVPages, nHPages: Smallint); stdcall;
    procedure SetPrintTitlesFromSelection; stdcall;
    procedure SetProtection(bLocked, bHidden: TOleBool); stdcall;
    procedure SetRowHeight(nR1, nR2: Integer; nHeight: Smallint; bDefRowHeight: TOleBool); stdcall;
    procedure SetRowHeightAuto(nR1, nC1, nR2, nC2: Integer; bSetDefaults: TOleBool); stdcall;
    procedure SetSelection(nR1, nC1, nR2, nC2: Integer); stdcall;
    procedure ShowActiveCell; stdcall;
    procedure Sort3(nR1, nC1, nR2, nC2: Integer; bSortByRows: TOleBool; nKey1, nKey2, nKey3: Integer); stdcall;
    procedure SortDlg; stdcall;
    procedure StartEdit(bClear, bInCellEditFocus, bArrowsExitEditMode: TOleBool); stdcall;
    procedure SwapTables(hSS2: Integer); stdcall;
    procedure TransactCommit; stdcall;
    procedure TransactRollback; stdcall;
    procedure TransactStart; stdcall;
    procedure TwipsToRC(x, y: Integer; var pRow, pCol: Integer); stdcall;
    procedure SSUpdate; stdcall;
    function SSVersion: Smallint; stdcall;
    procedure Write(const pPathName: string; FileType: Smallint); stdcall;
    procedure WriteToBlob(var phBlob: Integer; nReservedBytes: Smallint); stdcall;
    procedure SetRowHidden(nRow1, nRow2: Integer; bHidden: TOleBool); stdcall;
    procedure SetColHidden(nCol1, nCol2: Integer; bHidden: TOleBool); stdcall;
    procedure SetColWidthTwips(nCol1, nCol2, nWidth: Integer; bDefColWidth: TOleBool); stdcall;
    procedure EditInsertSheets; stdcall;
    procedure EditDeleteSheets; stdcall;
    procedure InsertSheets(nSheet, nSheets: Integer); stdcall;
    procedure DeleteSheets(nSheet, nSheets: Integer); stdcall;
    procedure Refresh; stdcall;
    function NextColPageBreak(Col: Integer): Integer; stdcall;
    function NextRowPageBreak(Row: Integer): Integer; stdcall;
    function ObjFirstID: Integer; stdcall;
    function ObjNextID(ID: Integer): Integer; stdcall;
    function ObjGetItemCount(ID: Integer): Smallint; stdcall;
    function ObjGetType(ID: Integer): Smallint; stdcall;
    function ObjGetSelectionCount: Smallint; stdcall;
    function FormatRCNr(Row, Col: Integer; DoAbsolute: TOleBool): string; stdcall;
    function SS: Integer; stdcall;
    function ErrorNumberToText(SSError: Integer): string; stdcall;
    function ObjNameToID(const Name: string): Integer; stdcall;
    function DefinedNameCount: Integer; stdcall;
    procedure ValidationRuleDlg; stdcall;
    procedure SetValidationRule(const Rule, Text: string); stdcall;
    procedure GetValidationRule(var Rule, Text: string); stdcall;
    function AutoFillItemsCount: Smallint; stdcall;
    procedure CopyRangeEx(nDstSheet, nDstR1, nDstC1, nDstR2, nDstC2, hSrcSS, nSrcSheet, nSrcR1, nSrcC1, nSrcR2, nSrcC2: Integer); stdcall;
    procedure Sort(nR1, nC1, nR2, nC2: Integer; bSortByRows: TOleBool; const Keys: Variant); stdcall;
    procedure DeleteAutoFillItems(nIndex: Smallint); stdcall;
    procedure ODBCConnect(var pConnect: string; bShowErrors: TOleBool; var pRetCode: Smallint); stdcall;
    procedure ODBCDisconnect; stdcall;
    procedure ODBCQuery(var pQuery: string; nRow, nCol: Integer; bForceShowDlg: TOleBool; var pSetColNames, pSetColFormats, pSetColWidths, pSetMaxRC: TOleBool; var pRetCode: Smallint); stdcall;
    procedure LaunchDesigner; stdcall;
    procedure AboutBox; stdcall;
    property ColText[nCol: Integer]: string read Get_ColText write Set_ColText;
    property DefinedName[const pName: string]: string read Get_DefinedName write Set_DefinedName;
    property EntryRC[nRow, nCol: Integer]: string read Get_EntryRC write Set_EntryRC;
    property FormattedTextRC[nRow, nCol: Integer]: string read Get_FormattedTextRC write Set_FormattedTextRC;
    property FormulaRC[nRow, nCol: Integer]: string read Get_FormulaRC write Set_FormulaRC;
    property LastColForRow[nRow: Integer]: Integer read Get_LastColForRow write Set_LastColForRow;
    property LogicalRC[nRow, nCol: Integer]: TOleBool read Get_LogicalRC write Set_LogicalRC;
    property NumberRC[nRow, nCol: Integer]: Double read Get_NumberRC write Set_NumberRC;
    property RowText[nRow: Integer]: string read Get_RowText write Set_RowText;
    property TextRC[nRow, nCol: Integer]: string read Get_TextRC write Set_TextRC;
    property TypeRC[nRow, nCol: Integer]: Smallint read Get_TypeRC write Set_TypeRC;
    property ColWidth[nCol: Integer]: Smallint read Get_ColWidth write Set_ColWidth;
    property RowHeight[nRow: Integer]: Smallint read Get_RowHeight write Set_RowHeight;
    property DefinedNameByIndex[nName: Integer]: string read Get_DefinedNameByIndex write Set_DefinedNameByIndex;
    property SheetName[nSheet: Integer]: string read Get_SheetName write Set_SheetName;
    property PaletteEntry[nEntry: Integer]: TColor read Get_PaletteEntry write Set_PaletteEntry;
    property ColWidthTwips[Col: Integer]: Smallint read Get_ColWidthTwips write Set_ColWidthTwips;
    property ObjItem[ID: Integer; Item: Smallint]: string read Get_ObjItem write Set_ObjItem;
    property ObjItems[ID: Integer]: string read Get_ObjItems write Set_ObjItems;
    property ObjName[ID: Integer]: string read Get_ObjName write Set_ObjName;
    property ObjText[ID: Integer]: string read Get_ObjText write Set_ObjText;
    property ObjValue[ID: Integer]: Smallint read Get_ObjValue write Set_ObjValue;
    property ObjVisible[ID: Integer]: TOleBool read Get_ObjVisible write Set_ObjVisible;
    property AutoFillItems[Index: Smallint]: string read Get_AutoFillItems write Set_AutoFillItems;
    property ColHidden[nCol: Integer]: TOleBool read Get_ColHidden write Set_ColHidden;
    property RowHidden[nRow: Integer]: TOleBool read Get_RowHidden write Set_RowHidden;
    property SheetSelected[nSheet: Integer]: TOleBool read Get_SheetSelected write Set_SheetSelected;
  published
    property TabStop;
    property DragCursor;
    property DragMode;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property Visible;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnStartDrag;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property BackColor: TColor index 3 read GetColorProp write SetColorProp stored False;
    property Col: Integer index 4 read GetIntegerProp write SetIntegerProp stored False;
    property Row: Integer index 5 read GetIntegerProp write SetIntegerProp stored False;
    property ShowHScrollBar: Smallint index 6 read GetSmallintProp write SetSmallintProp stored False;
    property Text: string index 7 read GetStringProp write SetStringProp stored False;
    property Number: Double index 8 read GetDoubleProp write SetDoubleProp stored False;
    property Formula: string index 9 read GetStringProp write SetStringProp stored False;
    property FixedCol: Integer index 10 read GetIntegerProp write SetIntegerProp stored False;
    property FixedCols: Integer index 11 read GetIntegerProp write SetIntegerProp stored False;
    property FixedRow: Integer index 12 read GetIntegerProp write SetIntegerProp stored False;
    property FixedRows: Integer index 13 read GetIntegerProp write SetIntegerProp stored False;
    property ShowGridLines: TOleBool index 14 read GetOleBoolProp write SetOleBoolProp stored False;
    property ShowRowHeading: TOleBool index 15 read GetOleBoolProp write SetOleBoolProp stored False;
    property ShowSelections: Smallint index 16 read GetSmallintProp write SetSmallintProp stored False;
    property LeftCol: Integer index 17 read GetIntegerProp write SetIntegerProp stored False;
    property MaxCol: Integer index 18 read GetIntegerProp write SetIntegerProp stored False;
    property MaxRow: Integer index 19 read GetIntegerProp write SetIntegerProp stored False;
    property TopRow: Integer index 20 read GetIntegerProp write SetIntegerProp stored False;
    property AllowResize: TOleBool index 21 read GetOleBoolProp write SetOleBoolProp stored False;
    property AllowSelections: TOleBool index 22 read GetOleBoolProp write SetOleBoolProp stored False;
    property AllowFormulas: TOleBool index 23 read GetOleBoolProp write SetOleBoolProp stored False;
    property AllowInCellEditing: TOleBool index 24 read GetOleBoolProp write SetOleBoolProp stored False;
    property ShowVScrollBar: Smallint index 25 read GetSmallintProp write SetSmallintProp stored False;
    property AllowFillRange: TOleBool index 26 read GetOleBoolProp write SetOleBoolProp stored False;
    property AllowMoveRange: TOleBool index 27 read GetOleBoolProp write SetOleBoolProp stored False;
    property SelStartCol: Integer index 28 read GetIntegerProp write SetIntegerProp stored False;
    property SelStartRow: Integer index 29 read GetIntegerProp write SetIntegerProp stored False;
    property SelEndCol: Integer index 30 read GetIntegerProp write SetIntegerProp stored False;
    property SelEndRow: Integer index 31 read GetIntegerProp write SetIntegerProp stored False;
    property ExtraColor: TColor index 32 read GetColorProp write SetColorProp stored False;
    property FileName: string index 33 read GetStringProp write SetStringProp stored False;
    property AutoRecalc: TOleBool index 34 read GetOleBoolProp write SetOleBoolProp stored False;
    property PrintGridLines: TOleBool index 35 read GetOleBoolProp write SetOleBoolProp stored False;
    property PrintRowHeading: TOleBool index 36 read GetOleBoolProp write SetOleBoolProp stored False;
    property PrintHCenter: TOleBool index 37 read GetOleBoolProp write SetOleBoolProp stored False;
    property PrintVCenter: TOleBool index 38 read GetOleBoolProp write SetOleBoolProp stored False;
    property PrintLeftToRight: TOleBool index 39 read GetOleBoolProp write SetOleBoolProp stored False;
    property PrintHeader: string index 40 read GetStringProp write SetStringProp stored False;
    property PrintFooter: string index 41 read GetStringProp write SetStringProp stored False;
    property PrintLeftMargin: Double index 42 read GetDoubleProp write SetDoubleProp stored False;
    property PrintTopMargin: Double index 43 read GetDoubleProp write SetDoubleProp stored False;
    property PrintRightMargin: Double index 44 read GetDoubleProp write SetDoubleProp stored False;
    property PrintBottomMargin: Double index 45 read GetDoubleProp write SetDoubleProp stored False;
    property PrintArea: string index 46 read GetStringProp write SetStringProp stored False;
    property PrintTitles: string index 47 read GetStringProp write SetStringProp stored False;
    property PrintNoColor: TOleBool index 48 read GetOleBoolProp write SetOleBoolProp stored False;
    property Selection: string index 49 read GetStringProp write SetStringProp stored False;
    property TableName: string index 50 read GetStringProp write SetStringProp stored False;
    property DoCancelEdit: TOleBool index 51 read GetOleBoolProp write SetOleBoolProp stored False;
    property DoSelChange: TOleBool index 52 read GetOleBoolProp write SetOleBoolProp stored False;
    property DoStartEdit: TOleBool index 53 read GetOleBoolProp write SetOleBoolProp stored False;
    property DoEndEdit: TOleBool index 54 read GetOleBoolProp write SetOleBoolProp stored False;
    property DoStartRecalc: TOleBool index 55 read GetOleBoolProp write SetOleBoolProp stored False;
    property DoEndRecalc: TOleBool index 56 read GetOleBoolProp write SetOleBoolProp stored False;
    property DoClick: TOleBool index 57 read GetOleBoolProp write SetOleBoolProp stored False;
    property DoDblClick: TOleBool index 58 read GetOleBoolProp write SetOleBoolProp stored False;
    property ShowColHeading: TOleBool index 59 read GetOleBoolProp write SetOleBoolProp stored False;
    property PrintColHeading: TOleBool index 60 read GetOleBoolProp write SetOleBoolProp stored False;
    property Entry: string index 61 read GetStringProp write SetStringProp stored False;
    property Repaint: TOleBool index 62 read GetOleBoolProp write SetOleBoolProp stored False;
    property AllowArrows: TOleBool index 63 read GetOleBoolProp write SetOleBoolProp stored False;
    property AllowTabs: TOleBool index 64 read GetOleBoolProp write SetOleBoolProp stored False;
    property FormattedText: string index 65 read GetStringProp write SetStringProp stored False;
    property RowMode: TOleBool index 66 read GetOleBoolProp write SetOleBoolProp stored False;
    property AllowDelete: TOleBool index 67 read GetOleBoolProp write SetOleBoolProp stored False;
    property EnableProtection: TOleBool index 68 read GetOleBoolProp write SetOleBoolProp stored False;
    property MinCol: Integer index 69 read GetIntegerProp write SetIntegerProp stored False;
    property MinRow: Integer index 70 read GetIntegerProp write SetIntegerProp stored False;
    property DoTopLeftChanged: TOleBool index 71 read GetOleBoolProp write SetOleBoolProp stored False;
    property AllowEditHeaders: TOleBool index 72 read GetOleBoolProp write SetOleBoolProp stored False;
    property DoObjClick: TOleBool index 73 read GetOleBoolProp write SetOleBoolProp stored False;
    property DoObjDblClick: TOleBool index 74 read GetOleBoolProp write SetOleBoolProp stored False;
    property AllowObjSelections: TOleBool index 75 read GetOleBoolProp write SetOleBoolProp stored False;
    property DoRClick: TOleBool index 76 read GetOleBoolProp write SetOleBoolProp stored False;
    property DoRDblClick: TOleBool index 77 read GetOleBoolProp write SetOleBoolProp stored False;
    property Clip: string index 78 read GetStringProp write SetStringProp stored False;
    property ClipValues: string index 79 read GetStringProp write SetStringProp stored False;
    property PrintLandscape: TOleBool index 80 read GetOleBoolProp write SetOleBoolProp stored False;
    property Enabled: TOleBool index -514 read GetOleBoolProp write SetOleBoolProp stored False;
    property BorderStyle: Smallint index -504 read GetSmallintProp write SetSmallintProp stored False;
    property AppName: string index 81 read GetStringProp write SetStringProp stored False;
    property HdrHeight: Smallint index 82 read GetSmallintProp write SetSmallintProp stored False;
    property HdrWidth: Smallint index 83 read GetSmallintProp write SetSmallintProp stored False;
    property NumberFormat: string index 84 read GetStringProp write SetStringProp stored False;
    property TopLeftText: string index 85 read GetStringProp write SetStringProp stored False;
    property EnterMovesDown: TOleBool index 86 read GetOleBoolProp write SetOleBoolProp stored False;
    property LastCol: Integer index 87 read GetIntegerProp write SetIntegerProp stored False;
    property LastRow: Integer index 88 read GetIntegerProp write SetIntegerProp stored False;
    property Logical: TOleBool index 89 read GetOleBoolProp write SetOleBoolProp stored False;
    property Mode: Smallint index 90 read GetSmallintProp write SetSmallintProp stored False;
    property PolyEditMode: Smallint index 91 read GetSmallintProp write SetSmallintProp stored False;
    property ViewScale: Smallint index 92 read GetSmallintProp write SetSmallintProp stored False;
    property SelectionCount: Smallint index 93 read GetSmallintProp write SetSmallintProp stored False;
    property Title: string index 94 read GetStringProp write SetStringProp stored False;
    property Type_: Smallint index 95 read GetSmallintProp write SetSmallintProp stored False;
    property ShowFormulas: TOleBool index 96 read GetOleBoolProp write SetOleBoolProp stored False;
    property ShowZeroValues: TOleBool index 97 read GetOleBoolProp write SetOleBoolProp stored False;
    property MousePointer: Smallint index 2 read GetSmallintProp write SetSmallintProp stored False;
    property MouseIcon: Variant index 98 read GetVariantProp write SetVariantProp stored False;
    property DoObjValueChanged: TOleBool index 99 read GetOleBoolProp write SetOleBoolProp stored False;
    property ScrollToLastRC: TOleBool index 100 read GetOleBoolProp write SetOleBoolProp stored False;
    property Modified: TOleBool index 101 read GetOleBoolProp write SetOleBoolProp stored False;
    property DoObjGotFocus: TOleBool index 102 read GetOleBoolProp write SetOleBoolProp stored False;
    property DoObjLostFocus: TOleBool index 103 read GetOleBoolProp write SetOleBoolProp stored False;
    property PrintDevMode: Integer index 104 read GetIntegerProp write SetIntegerProp stored False;
    property NumSheets: Integer index 105 read GetIntegerProp write SetIntegerProp stored False;
    property Sheet: Integer index 106 read GetIntegerProp write SetIntegerProp stored False;
    property ColWidthUnits: Smallint index 107 read GetSmallintProp write SetSmallintProp stored False;
    property ShowTypeMarkers: TOleBool index 108 read GetOleBoolProp write SetOleBoolProp stored False;
    property ShowTabs: Smallint index 109 read GetSmallintProp write SetSmallintProp stored False;
    property ShowEditBar: TOleBool index 110 read GetOleBoolProp write SetOleBoolProp stored False;
    property ShowEditBarCellRef: TOleBool index 111 read GetOleBoolProp write SetOleBoolProp stored False;
    property AllowDesigner: TOleBool index 1 read GetOleBoolProp write SetOleBoolProp stored False;
    property hWnd: Integer index -515 read GetIntegerProp write SetIntegerProp stored False;
    property AllowAutoFill: TOleBool index 112 read GetOleBoolProp write SetOleBoolProp stored False;
    property OnClick: TVCFormulaOneClick read FOnClick write FOnClick;
    property OnDblClick: TVCFormulaOneDblClick read FOnDblClick write FOnDblClick;
    property OnCancelEdit: TNotifyEvent read FOnCancelEdit write FOnCancelEdit;
    property OnSelChange: TNotifyEvent read FOnSelChange write FOnSelChange;
    property OnStartEdit: TVCFormulaOneStartEdit read FOnStartEdit write FOnStartEdit;
    property OnEndEdit: TVCFormulaOneEndEdit read FOnEndEdit write FOnEndEdit;
    property OnStartRecalc: TNotifyEvent read FOnStartRecalc write FOnStartRecalc;
    property OnEndRecalc: TNotifyEvent read FOnEndRecalc write FOnEndRecalc;
    property OnTopLeftChanged: TNotifyEvent read FOnTopLeftChanged write FOnTopLeftChanged;
    property OnObjClick: TVCFormulaOneObjClick read FOnObjClick write FOnObjClick;
    property OnObjDblClick: TVCFormulaOneObjDblClick read FOnObjDblClick write FOnObjDblClick;
    property OnRClick: TVCFormulaOneRClick read FOnRClick write FOnRClick;
    property OnRDblClick: TVCFormulaOneRDblClick read FOnRDblClick write FOnRDblClick;
    property OnObjValueChanged: TVCFormulaOneObjValueChanged read FOnObjValueChanged write FOnObjValueChanged;
    property OnModified: TNotifyEvent read FOnModified write FOnModified;
    property OnObjGotFocus: TVCFormulaOneObjGotFocus read FOnObjGotFocus write FOnObjGotFocus;
    property OnObjLostFocus: TVCFormulaOneObjLostFocus read FOnObjLostFocus write FOnObjLostFocus;
    property OnValidationFailed: TVCFormulaOneValidationFailed read FOnValidationFailed write FOnValidationFailed;
  end;

procedure Register;

implementation

{$J+}

procedure TVCFormulaOne.InitControlData;
const
  CEventDispIDs: array[0..17] of Integer = (
    $00000001, $00000002, $00000003, $00000004, $00000005, $00000006,
    $00000007, $00000008, $00000009, $0000000A, $0000000B, $0000000C,
    $0000000D, $0000000E, $0000000F, $00000010, $00000011, $00000012);
  CLicenseKey: array[0..42] of Word = (
    $0043, $006F, $0070, $0079, $0072, $0069, $0067, $0068, $0074, $0020,
    $0028, $0063, $0029, $0020, $0031, $0039, $0039, $0035, $0020, $0056,
    $0069, $0073, $0075, $0061, $006C, $0020, $0043, $006F, $006D, $0070,
    $006F, $006E, $0065, $006E, $0074, $0073, $002C, $0020, $0049, $006E,
    $0063, $002E, $0000);
  CControlData: TControlData = (
    ClassID: (
      D1:$042BADC5;D2:$5E58;D3:$11CE;D4:($B6,$10,$52,$41,$53,$48,$00,$01));
    EventIID: (
      D1:$042BADC7;D2:$5E58;D3:$11CE;D4:($B6,$10,$52,$41,$53,$48,$00,$01));
    EventCount: 18;
    EventDispIDs: @CEventDispIDs;
    LicenseKey: @CLicenseKey;
    Flags: $00000008);
begin
  ControlData := @CControlData;
end;

procedure TVCFormulaOne.EditPasteValues;
const
  DispInfo: array[0..7] of Byte = ($71,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.GetAlignment;
const
  DispInfo: array[0..11] of Byte = ($72,$00,$00,$00,$00,$01,$04,$00,$82,$8B,$82,$82);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.GetBorder;
const
  DispInfo: array[0..16] of Byte = ($73,$00,$00,$00,$00,$01,$09,$00,$82,$82,$82,$82,$82,$83,$83,$83,$83);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.GetFont;
const
  DispInfo: array[0..16] of Byte = ($74,$00,$00,$00,$00,$01,$09,$00,$88,$82,$8B,$8B,$8B,$8B,$83,$8B,$8B);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.GetLineStyle;
const
  DispInfo: array[0..10] of Byte = ($75,$00,$00,$00,$00,$01,$03,$00,$82,$83,$82);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.GetPattern;
const
  DispInfo: array[0..10] of Byte = ($76,$00,$00,$00,$00,$01,$03,$00,$82,$83,$83);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.GetProtection;
const
  DispInfo: array[0..9] of Byte = ($77,$00,$00,$00,$00,$01,$02,$00,$8B,$8B);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.GetTabbedText;
const
  DispInfo: array[0..13] of Byte = ($78,$00,$00,$00,$00,$01,$06,$00,$03,$03,$03,$03,$0B,$83);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.SetTabbedText;
const
  DispInfo: array[0..13] of Byte = ($79,$00,$00,$00,$00,$01,$06,$00,$03,$03,$83,$83,$0B,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.AddColPageBreak;
const
  DispInfo: array[0..8] of Byte = ($7A,$00,$00,$00,$00,$01,$01,$00,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.AddPageBreak;
const
  DispInfo: array[0..7] of Byte = ($7B,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.AddRowPageBreak;
const
  DispInfo: array[0..8] of Byte = ($7C,$00,$00,$00,$00,$01,$01,$00,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.AddSelection;
const
  DispInfo: array[0..11] of Byte = ($7D,$00,$00,$00,$00,$01,$04,$00,$03,$03,$03,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.Attach;
const
  DispInfo: array[0..8] of Byte = ($7E,$00,$00,$00,$00,$01,$01,$00,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.AttachToSS;
const
  DispInfo: array[0..8] of Byte = ($7F,$00,$00,$00,$00,$01,$01,$00,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.CalculationDlg;
const
  DispInfo: array[0..7] of Byte = ($80,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.CancelEdit;
const
  DispInfo: array[0..7] of Byte = ($81,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.CheckRecalc;
const
  DispInfo: array[0..7] of Byte = ($82,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.ClearClipboard;
const
  DispInfo: array[0..7] of Byte = ($83,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.ClearRange;
const
  DispInfo: array[0..12] of Byte = ($84,$00,$00,$00,$00,$01,$05,$00,$03,$03,$03,$03,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.ColorPaletteDlg;
const
  DispInfo: array[0..7] of Byte = ($85,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.ColWidthDlg;
const
  DispInfo: array[0..7] of Byte = ($86,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.CopyAll;
const
  DispInfo: array[0..8] of Byte = ($87,$00,$00,$00,$00,$01,$01,$00,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.CopyRange;
const
  DispInfo: array[0..16] of Byte = ($88,$00,$00,$00,$00,$01,$09,$00,$03,$03,$03,$03,$03,$03,$03,$03,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.DefinedNameDlg;
const
  DispInfo: array[0..7] of Byte = ($89,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.DeleteDefinedName;
const
  DispInfo: array[0..8] of Byte = ($8A,$00,$00,$00,$00,$01,$01,$00,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.DeleteRange;
const
  DispInfo: array[0..12] of Byte = ($8B,$00,$00,$00,$00,$01,$05,$00,$03,$03,$03,$03,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.Draw;
const
  DispInfo: array[0..20] of Byte = ($8C,$00,$00,$00,$00,$01,$0D,$00,$03,$03,$03,$03,$03,$03,$03,$83,$83,$03,$03,$03,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.EditClear;
const
  DispInfo: array[0..8] of Byte = ($8D,$00,$00,$00,$00,$01,$01,$00,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.EditCopy;
const
  DispInfo: array[0..7] of Byte = ($8E,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.EditCopyDown;
const
  DispInfo: array[0..7] of Byte = ($8F,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.EditCopyRight;
const
  DispInfo: array[0..7] of Byte = ($90,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.EditCut;
const
  DispInfo: array[0..7] of Byte = ($91,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.EditDelete;
const
  DispInfo: array[0..8] of Byte = ($92,$00,$00,$00,$00,$01,$01,$00,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.EditInsert;
const
  DispInfo: array[0..8] of Byte = ($93,$00,$00,$00,$00,$01,$01,$00,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.EditPaste;
const
  DispInfo: array[0..7] of Byte = ($94,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.EndEdit;
const
  DispInfo: array[0..7] of Byte = ($95,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.FilePageSetupDlg;
const
  DispInfo: array[0..7] of Byte = ($96,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.FilePrint;
const
  DispInfo: array[0..8] of Byte = ($97,$00,$00,$00,$00,$01,$01,$00,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.FilePrintSetupDlg;
const
  DispInfo: array[0..7] of Byte = ($98,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.FormatAlignmentDlg;
const
  DispInfo: array[0..7] of Byte = ($99,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.FormatBorderDlg;
const
  DispInfo: array[0..7] of Byte = ($9A,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.FormatCurrency0;
const
  DispInfo: array[0..7] of Byte = ($9B,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.FormatCurrency2;
const
  DispInfo: array[0..7] of Byte = ($9C,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.FormatDefaultFontDlg;
const
  DispInfo: array[0..7] of Byte = ($9D,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.FormatFixed;
const
  DispInfo: array[0..7] of Byte = ($9E,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.FormatFixed2;
const
  DispInfo: array[0..7] of Byte = ($9F,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.FormatFontDlg;
const
  DispInfo: array[0..7] of Byte = ($A0,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.FormatFraction;
const
  DispInfo: array[0..7] of Byte = ($A1,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.FormatGeneral;
const
  DispInfo: array[0..7] of Byte = ($A2,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.FormatHmmampm;
const
  DispInfo: array[0..7] of Byte = ($A3,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.FormatMdyy;
const
  DispInfo: array[0..7] of Byte = ($A4,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.FormatNumberDlg;
const
  DispInfo: array[0..7] of Byte = ($A5,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.FormatPatternDlg;
const
  DispInfo: array[0..7] of Byte = ($A6,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.FormatPercent;
const
  DispInfo: array[0..7] of Byte = ($A7,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.FormatScientific;
const
  DispInfo: array[0..7] of Byte = ($A8,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.GetActiveCell;
const
  DispInfo: array[0..9] of Byte = ($A9,$00,$00,$00,$00,$01,$02,$00,$83,$83);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.GetDefaultFont;
const
  DispInfo: array[0..9] of Byte = ($AA,$00,$00,$00,$00,$01,$02,$00,$88,$82);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.GetHdrSelection;
const
  DispInfo: array[0..10] of Byte = ($AB,$00,$00,$00,$00,$01,$03,$00,$8B,$8B,$8B);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.GetIteration;
const
  DispInfo: array[0..10] of Byte = ($AC,$00,$00,$00,$00,$01,$03,$00,$8B,$82,$85);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.GetPrintScale;
const
  DispInfo: array[0..11] of Byte = ($AD,$00,$00,$00,$00,$01,$04,$00,$82,$8B,$83,$83);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.GetSelection;
const
  DispInfo: array[0..12] of Byte = ($AE,$00,$00,$00,$00,$01,$05,$00,$02,$83,$83,$83,$83);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.GotoDlg;
const
  DispInfo: array[0..7] of Byte = ($AF,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.HeapMin;
const
  DispInfo: array[0..7] of Byte = ($B0,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.InitTable;
const
  DispInfo: array[0..7] of Byte = ($B1,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.InsertRange;
const
  DispInfo: array[0..12] of Byte = ($B2,$00,$00,$00,$00,$01,$05,$00,$03,$03,$03,$03,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.LineStyleDlg;
const
  DispInfo: array[0..7] of Byte = ($B3,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.MoveRange;
const
  DispInfo: array[0..13] of Byte = ($B4,$00,$00,$00,$00,$01,$06,$00,$03,$03,$03,$03,$03,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.ObjAddItem;
const
  DispInfo: array[0..9] of Byte = ($B5,$00,$00,$00,$00,$01,$02,$00,$03,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.ObjAddSelection;
const
  DispInfo: array[0..8] of Byte = ($B6,$00,$00,$00,$00,$01,$01,$00,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.ObjBringToFront;
const
  DispInfo: array[0..7] of Byte = ($B7,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.ObjDeleteItem;
const
  DispInfo: array[0..9] of Byte = ($B8,$00,$00,$00,$00,$01,$02,$00,$03,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.ObjGetCell;
const
  DispInfo: array[0..11] of Byte = ($B9,$00,$00,$00,$00,$01,$04,$00,$03,$82,$83,$83);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.ObjGetPos;
const
  DispInfo: array[0..12] of Byte = ($BA,$00,$00,$00,$00,$01,$05,$00,$03,$84,$84,$84,$84);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.ObjGetSelection;
const
  DispInfo: array[0..9] of Byte = ($BB,$00,$00,$00,$00,$01,$02,$00,$02,$83);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.ObjInsertItem;
const
  DispInfo: array[0..10] of Byte = ($BC,$00,$00,$00,$00,$01,$03,$00,$03,$02,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.ObjNameDlg;
const
  DispInfo: array[0..7] of Byte = ($BD,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.ObjNew;
const
  DispInfo: array[0..13] of Byte = ($BE,$00,$00,$00,$00,$01,$06,$00,$02,$04,$04,$04,$04,$83);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.ObjNewPicture;
const
  DispInfo: array[0..16] of Byte = ($BF,$00,$00,$00,$00,$01,$09,$00,$04,$04,$04,$04,$83,$03,$03,$03,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.ObjOptionsDlg;
const
  DispInfo: array[0..7] of Byte = ($C0,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.ObjPosToTwips;
const
  DispInfo: array[0..16] of Byte = ($C1,$00,$00,$00,$00,$01,$09,$00,$04,$04,$04,$04,$83,$83,$83,$83,$82);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.ObjSendToBack;
const
  DispInfo: array[0..7] of Byte = ($C2,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.ObjSetCell;
const
  DispInfo: array[0..11] of Byte = ($C3,$00,$00,$00,$00,$01,$04,$00,$03,$02,$03,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.ObjSetPicture;
const
  DispInfo: array[0..12] of Byte = ($C4,$00,$00,$00,$00,$01,$05,$00,$03,$03,$02,$03,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.ObjSetPos;
const
  DispInfo: array[0..12] of Byte = ($C5,$00,$00,$00,$00,$01,$05,$00,$03,$04,$04,$04,$04);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.ObjSetSelection;
const
  DispInfo: array[0..8] of Byte = ($C6,$00,$00,$00,$00,$01,$01,$00,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.OpenFileDlg;
const
  DispInfo: array[0..10] of Byte = ($C7,$00,$00,$00,$00,$01,$03,$00,$08,$03,$88);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.ProtectionDlg;
const
  DispInfo: array[0..7] of Byte = ($C8,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.RangeToTwips;
const
  DispInfo: array[0..16] of Byte = ($C9,$00,$00,$00,$00,$01,$09,$00,$03,$03,$03,$03,$83,$83,$83,$83,$82);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.Read;
const
  DispInfo: array[0..9] of Byte = ($CA,$00,$00,$00,$00,$01,$02,$00,$08,$82);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.ReadFromBlob;
const
  DispInfo: array[0..9] of Byte = ($CB,$00,$00,$00,$00,$01,$02,$00,$03,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.Recalc;
const
  DispInfo: array[0..7] of Byte = ($CC,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.RemoveColPageBreak;
const
  DispInfo: array[0..8] of Byte = ($CD,$00,$00,$00,$00,$01,$01,$00,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.RemovePageBreak;
const
  DispInfo: array[0..7] of Byte = ($CE,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.RemoveRowPageBreak;
const
  DispInfo: array[0..8] of Byte = ($CF,$00,$00,$00,$00,$01,$01,$00,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.RowHeightDlg;
const
  DispInfo: array[0..7] of Byte = ($D0,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.SaveFileDlg;
const
  DispInfo: array[0..10] of Byte = ($D1,$00,$00,$00,$00,$01,$03,$00,$08,$88,$82);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.SaveWindowInfo;
const
  DispInfo: array[0..7] of Byte = ($D2,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.SetActiveCell;
const
  DispInfo: array[0..9] of Byte = ($D3,$00,$00,$00,$00,$01,$02,$00,$03,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.SetAlignment;
const
  DispInfo: array[0..11] of Byte = ($D4,$00,$00,$00,$00,$01,$04,$00,$02,$0B,$02,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.SetBorder;
const
  DispInfo: array[0..18] of Byte = ($D5,$00,$00,$00,$00,$01,$0B,$00,$02,$02,$02,$02,$02,$02,$03,$03,$03,$03,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.SetColWidth;
const
  DispInfo: array[0..11] of Byte = ($D6,$00,$00,$00,$00,$01,$04,$00,$03,$03,$02,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.SetColWidthAuto;
const
  DispInfo: array[0..12] of Byte = ($D7,$00,$00,$00,$00,$01,$05,$00,$03,$03,$03,$03,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.SetDefaultFont;
const
  DispInfo: array[0..9] of Byte = ($D8,$00,$00,$00,$00,$01,$02,$00,$08,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.SetFont;
const
  DispInfo: array[0..16] of Byte = ($D9,$00,$00,$00,$00,$01,$09,$00,$08,$02,$0B,$0B,$0B,$0B,$03,$0B,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.SetHdrSelection;
const
  DispInfo: array[0..10] of Byte = ($DA,$00,$00,$00,$00,$01,$03,$00,$0B,$0B,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.SetIteration;
const
  DispInfo: array[0..10] of Byte = ($DB,$00,$00,$00,$00,$01,$03,$00,$0B,$02,$05);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.SetLineStyle;
const
  DispInfo: array[0..10] of Byte = ($DC,$00,$00,$00,$00,$01,$03,$00,$02,$03,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.SetPattern;
const
  DispInfo: array[0..10] of Byte = ($DD,$00,$00,$00,$00,$01,$03,$00,$02,$03,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.SetPrintAreaFromSelection;
const
  DispInfo: array[0..7] of Byte = ($DE,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.SetPrintScale;
const
  DispInfo: array[0..11] of Byte = ($DF,$00,$00,$00,$00,$01,$04,$00,$02,$0B,$02,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.SetPrintTitlesFromSelection;
const
  DispInfo: array[0..7] of Byte = ($E0,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.SetProtection;
const
  DispInfo: array[0..9] of Byte = ($E1,$00,$00,$00,$00,$01,$02,$00,$0B,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.SetRowHeight;
const
  DispInfo: array[0..11] of Byte = ($E2,$00,$00,$00,$00,$01,$04,$00,$03,$03,$02,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.SetRowHeightAuto;
const
  DispInfo: array[0..12] of Byte = ($E3,$00,$00,$00,$00,$01,$05,$00,$03,$03,$03,$03,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.SetSelection;
const
  DispInfo: array[0..11] of Byte = ($E4,$00,$00,$00,$00,$01,$04,$00,$03,$03,$03,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.ShowActiveCell;
const
  DispInfo: array[0..7] of Byte = ($E5,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.Sort3;
const
  DispInfo: array[0..15] of Byte = ($E6,$00,$00,$00,$00,$01,$08,$00,$03,$03,$03,$03,$0B,$03,$03,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.SortDlg;
const
  DispInfo: array[0..7] of Byte = ($E7,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.StartEdit;
const
  DispInfo: array[0..10] of Byte = ($E8,$00,$00,$00,$00,$01,$03,$00,$0B,$0B,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.SwapTables;
const
  DispInfo: array[0..8] of Byte = ($E9,$00,$00,$00,$00,$01,$01,$00,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.TransactCommit;
const
  DispInfo: array[0..7] of Byte = ($EA,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.TransactRollback;
const
  DispInfo: array[0..7] of Byte = ($EB,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.TransactStart;
const
  DispInfo: array[0..7] of Byte = ($EC,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.TwipsToRC;
const
  DispInfo: array[0..11] of Byte = ($ED,$00,$00,$00,$00,$01,$04,$00,$03,$03,$83,$83);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.SSUpdate;
const
  DispInfo: array[0..7] of Byte = ($EE,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCFormulaOne.SSVersion;
const
  DispInfo: array[0..7] of Byte = ($EF,$00,$00,$00,$02,$01,$00,$00);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCFormulaOne.Write;
const
  DispInfo: array[0..9] of Byte = ($F0,$00,$00,$00,$00,$01,$02,$00,$08,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.WriteToBlob;
const
  DispInfo: array[0..9] of Byte = ($F1,$00,$00,$00,$00,$01,$02,$00,$83,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.SetRowHidden;
const
  DispInfo: array[0..10] of Byte = ($F2,$00,$00,$00,$00,$01,$03,$00,$03,$03,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.SetColHidden;
const
  DispInfo: array[0..10] of Byte = ($F3,$00,$00,$00,$00,$01,$03,$00,$03,$03,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.SetColWidthTwips;
const
  DispInfo: array[0..11] of Byte = ($F4,$00,$00,$00,$00,$01,$04,$00,$03,$03,$03,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.EditInsertSheets;
const
  DispInfo: array[0..7] of Byte = ($F5,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.EditDeleteSheets;
const
  DispInfo: array[0..7] of Byte = ($F6,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.InsertSheets;
const
  DispInfo: array[0..9] of Byte = ($F7,$00,$00,$00,$00,$01,$02,$00,$03,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.DeleteSheets;
const
  DispInfo: array[0..9] of Byte = ($F8,$00,$00,$00,$00,$01,$02,$00,$03,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.Refresh;
const
  DispInfo: array[0..7] of Byte = ($DA,$FD,$FF,$FF,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCFormulaOne.NextColPageBreak;
const
  DispInfo: array[0..8] of Byte = ($F9,$00,$00,$00,$03,$01,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCFormulaOne.NextRowPageBreak;
const
  DispInfo: array[0..8] of Byte = ($FA,$00,$00,$00,$03,$01,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCFormulaOne.ObjFirstID;
const
  DispInfo: array[0..7] of Byte = ($FB,$00,$00,$00,$03,$01,$00,$00);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCFormulaOne.ObjNextID;
const
  DispInfo: array[0..8] of Byte = ($FC,$00,$00,$00,$03,$01,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCFormulaOne.ObjGetItemCount;
const
  DispInfo: array[0..8] of Byte = ($FD,$00,$00,$00,$02,$01,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCFormulaOne.ObjGetType;
const
  DispInfo: array[0..8] of Byte = ($FE,$00,$00,$00,$02,$01,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCFormulaOne.ObjGetSelectionCount;
const
  DispInfo: array[0..7] of Byte = ($FF,$00,$00,$00,$02,$01,$00,$00);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCFormulaOne.FormatRCNr;
const
  DispInfo: array[0..10] of Byte = ($00,$01,$00,$00,$08,$01,$03,$00,$03,$03,$0B);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCFormulaOne.SS;
const
  DispInfo: array[0..7] of Byte = ($01,$01,$00,$00,$03,$01,$00,$00);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCFormulaOne.ErrorNumberToText;
const
  DispInfo: array[0..8] of Byte = ($02,$01,$00,$00,$08,$01,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCFormulaOne.ObjNameToID;
const
  DispInfo: array[0..8] of Byte = ($03,$01,$00,$00,$03,$01,$01,$00,$08);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCFormulaOne.DefinedNameCount;
const
  DispInfo: array[0..7] of Byte = ($04,$01,$00,$00,$03,$01,$00,$00);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCFormulaOne.ValidationRuleDlg;
const
  DispInfo: array[0..7] of Byte = ($05,$01,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.SetValidationRule;
const
  DispInfo: array[0..9] of Byte = ($06,$01,$00,$00,$00,$01,$02,$00,$08,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.GetValidationRule;
const
  DispInfo: array[0..9] of Byte = ($07,$01,$00,$00,$00,$01,$02,$00,$88,$88);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCFormulaOne.AutoFillItemsCount;
const
  DispInfo: array[0..7] of Byte = ($08,$01,$00,$00,$02,$01,$00,$00);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCFormulaOne.CopyRangeEx;
const
  DispInfo: array[0..18] of Byte = ($09,$01,$00,$00,$00,$01,$0B,$00,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.Sort;
const
  DispInfo: array[0..13] of Byte = ($0A,$01,$00,$00,$00,$01,$06,$00,$03,$03,$03,$03,$0B,$0C);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.DeleteAutoFillItems;
const
  DispInfo: array[0..8] of Byte = ($0B,$01,$00,$00,$00,$01,$01,$00,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.ODBCConnect;
const
  DispInfo: array[0..10] of Byte = ($0C,$01,$00,$00,$00,$01,$03,$00,$88,$0B,$82);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.ODBCDisconnect;
const
  DispInfo: array[0..7] of Byte = ($0D,$01,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.ODBCQuery;
const
  DispInfo: array[0..16] of Byte = ($0E,$01,$00,$00,$00,$01,$09,$00,$88,$03,$03,$0B,$8B,$8B,$8B,$8B,$82);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.LaunchDesigner;
const
  DispInfo: array[0..7] of Byte = ($0F,$01,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFormulaOne.AboutBox;
const
  DispInfo: array[0..7] of Byte = ($D8,$FD,$FF,$FF,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCFormulaOne.Get_ColText;
const
  DispInfo: array[0..8] of Byte = ($10,$01,$00,$00,$08,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCFormulaOne.Set_ColText;
const
  DispInfo: array[0..9] of Byte = ($10,$01,$00,$00,$00,$04,$02,$00,$03,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCFormulaOne.Get_DefinedName;
const
  DispInfo: array[0..8] of Byte = ($11,$01,$00,$00,$08,$02,$01,$00,$08);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCFormulaOne.Set_DefinedName;
const
  DispInfo: array[0..9] of Byte = ($11,$01,$00,$00,$00,$04,$02,$00,$08,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCFormulaOne.Get_EntryRC;
const
  DispInfo: array[0..9] of Byte = ($12,$01,$00,$00,$08,$02,$02,$00,$03,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCFormulaOne.Set_EntryRC;
const
  DispInfo: array[0..10] of Byte = ($12,$01,$00,$00,$00,$04,$03,$00,$03,$03,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCFormulaOne.Get_FormattedTextRC;
const
  DispInfo: array[0..9] of Byte = ($13,$01,$00,$00,$08,$02,$02,$00,$03,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCFormulaOne.Set_FormattedTextRC;
const
  DispInfo: array[0..10] of Byte = ($13,$01,$00,$00,$00,$04,$03,$00,$03,$03,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCFormulaOne.Get_FormulaRC;
const
  DispInfo: array[0..9] of Byte = ($14,$01,$00,$00,$08,$02,$02,$00,$03,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCFormulaOne.Set_FormulaRC;
const
  DispInfo: array[0..10] of Byte = ($14,$01,$00,$00,$00,$04,$03,$00,$03,$03,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCFormulaOne.Get_LastColForRow;
const
  DispInfo: array[0..8] of Byte = ($15,$01,$00,$00,$03,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCFormulaOne.Set_LastColForRow;
const
  DispInfo: array[0..9] of Byte = ($15,$01,$00,$00,$00,$04,$02,$00,$03,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCFormulaOne.Get_LogicalRC;
const
  DispInfo: array[0..9] of Byte = ($16,$01,$00,$00,$0B,$02,$02,$00,$03,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCFormulaOne.Set_LogicalRC;
const
  DispInfo: array[0..10] of Byte = ($16,$01,$00,$00,$00,$04,$03,$00,$03,$03,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCFormulaOne.Get_NumberRC;
const
  DispInfo: array[0..9] of Byte = ($17,$01,$00,$00,$05,$02,$02,$00,$03,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCFormulaOne.Set_NumberRC;
const
  DispInfo: array[0..10] of Byte = ($17,$01,$00,$00,$00,$04,$03,$00,$03,$03,$05);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCFormulaOne.Get_RowText;
const
  DispInfo: array[0..8] of Byte = ($18,$01,$00,$00,$08,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCFormulaOne.Set_RowText;
const
  DispInfo: array[0..9] of Byte = ($18,$01,$00,$00,$00,$04,$02,$00,$03,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCFormulaOne.Get_TextRC;
const
  DispInfo: array[0..9] of Byte = ($19,$01,$00,$00,$08,$02,$02,$00,$03,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCFormulaOne.Set_TextRC;
const
  DispInfo: array[0..10] of Byte = ($19,$01,$00,$00,$00,$04,$03,$00,$03,$03,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCFormulaOne.Get_TypeRC;
const
  DispInfo: array[0..9] of Byte = ($1A,$01,$00,$00,$02,$02,$02,$00,$03,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCFormulaOne.Set_TypeRC;
const
  DispInfo: array[0..10] of Byte = ($1A,$01,$00,$00,$00,$04,$03,$00,$03,$03,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCFormulaOne.Get_ColWidth;
const
  DispInfo: array[0..8] of Byte = ($1B,$01,$00,$00,$02,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCFormulaOne.Set_ColWidth;
const
  DispInfo: array[0..9] of Byte = ($1B,$01,$00,$00,$00,$04,$02,$00,$03,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCFormulaOne.Get_RowHeight;
const
  DispInfo: array[0..8] of Byte = ($1C,$01,$00,$00,$02,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCFormulaOne.Set_RowHeight;
const
  DispInfo: array[0..9] of Byte = ($1C,$01,$00,$00,$00,$04,$02,$00,$03,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCFormulaOne.Get_DefinedNameByIndex;
const
  DispInfo: array[0..8] of Byte = ($1D,$01,$00,$00,$08,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCFormulaOne.Set_DefinedNameByIndex;
const
  DispInfo: array[0..9] of Byte = ($1D,$01,$00,$00,$00,$04,$02,$00,$03,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCFormulaOne.Get_SheetName;
const
  DispInfo: array[0..8] of Byte = ($1E,$01,$00,$00,$08,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCFormulaOne.Set_SheetName;
const
  DispInfo: array[0..9] of Byte = ($1E,$01,$00,$00,$00,$04,$02,$00,$03,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCFormulaOne.Get_PaletteEntry;
const
  DispInfo: array[0..8] of Byte = ($1F,$01,$00,$00,$03,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCFormulaOne.Set_PaletteEntry;
const
  DispInfo: array[0..9] of Byte = ($1F,$01,$00,$00,$00,$04,$02,$00,$03,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCFormulaOne.Get_ColWidthTwips;
const
  DispInfo: array[0..8] of Byte = ($20,$01,$00,$00,$02,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCFormulaOne.Set_ColWidthTwips;
const
  DispInfo: array[0..9] of Byte = ($20,$01,$00,$00,$00,$04,$02,$00,$03,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCFormulaOne.Get_ObjItem;
const
  DispInfo: array[0..9] of Byte = ($21,$01,$00,$00,$08,$02,$02,$00,$03,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCFormulaOne.Set_ObjItem;
const
  DispInfo: array[0..10] of Byte = ($21,$01,$00,$00,$00,$04,$03,$00,$03,$02,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCFormulaOne.Get_ObjItems;
const
  DispInfo: array[0..8] of Byte = ($22,$01,$00,$00,$08,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCFormulaOne.Set_ObjItems;
const
  DispInfo: array[0..9] of Byte = ($22,$01,$00,$00,$00,$04,$02,$00,$03,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCFormulaOne.Get_ObjName;
const
  DispInfo: array[0..8] of Byte = ($23,$01,$00,$00,$08,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCFormulaOne.Set_ObjName;
const
  DispInfo: array[0..9] of Byte = ($23,$01,$00,$00,$00,$04,$02,$00,$03,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCFormulaOne.Get_ObjText;
const
  DispInfo: array[0..8] of Byte = ($24,$01,$00,$00,$08,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCFormulaOne.Set_ObjText;
const
  DispInfo: array[0..9] of Byte = ($24,$01,$00,$00,$00,$04,$02,$00,$03,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCFormulaOne.Get_ObjValue;
const
  DispInfo: array[0..8] of Byte = ($25,$01,$00,$00,$02,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCFormulaOne.Set_ObjValue;
const
  DispInfo: array[0..9] of Byte = ($25,$01,$00,$00,$00,$04,$02,$00,$03,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCFormulaOne.Get_ObjVisible;
const
  DispInfo: array[0..8] of Byte = ($26,$01,$00,$00,$0B,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCFormulaOne.Set_ObjVisible;
const
  DispInfo: array[0..9] of Byte = ($26,$01,$00,$00,$00,$04,$02,$00,$03,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCFormulaOne.Get_AutoFillItems;
const
  DispInfo: array[0..8] of Byte = ($27,$01,$00,$00,$08,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCFormulaOne.Set_AutoFillItems;
const
  DispInfo: array[0..9] of Byte = ($27,$01,$00,$00,$00,$04,$02,$00,$02,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCFormulaOne.Get_ColHidden;
const
  DispInfo: array[0..8] of Byte = ($28,$01,$00,$00,$0B,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCFormulaOne.Set_ColHidden;
const
  DispInfo: array[0..9] of Byte = ($28,$01,$00,$00,$00,$04,$02,$00,$03,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCFormulaOne.Get_RowHidden;
const
  DispInfo: array[0..8] of Byte = ($29,$01,$00,$00,$0B,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCFormulaOne.Set_RowHidden;
const
  DispInfo: array[0..9] of Byte = ($29,$01,$00,$00,$00,$04,$02,$00,$03,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCFormulaOne.Get_SheetSelected;
const
  DispInfo: array[0..8] of Byte = ($2A,$01,$00,$00,$0B,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCFormulaOne.Set_SheetSelected;
const
  DispInfo: array[0..9] of Byte = ($2A,$01,$00,$00,$00,$04,$02,$00,$03,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure Register;
begin
  RegisterComponents('OCX', [TVCFormulaOne]);
end;

end.
