unit VCSpell;

interface

uses Ole2, OleCtl, Classes, Graphics, OleCtrls;

const

{ DictionaryCategories }

  VSCAT_STANDARD = 256;
  VSCAT_IRLIST = 256;
  VSCAT_CUSTOM = 512;
  VSCAT_ENABLED = 1024;
  VSCAT_DISABLED = 2048;

{ DictionaryStatusBits }

  VSDSTAT_ENABLED = 1;
  VSDSTAT_LOADED = 2;
  VSDSTAT_IRLIST_ENABLED = 4;
  VSDSTAT_UPDATEABLE = 8;
  VSDSTAT_READONLY = 16;
  VSDSTAT_EXTENDED = 32;
  VSDSTAT_HYPHENATION = 64;
  VSDSTAT_PHONETICS = 128;
  VSDSTAT_COMMONLIST = 256;

{ DictionaryLanguageCodes }

  VSLANG_AMERICAN = 0;
  VSLANG_ENGLISH = 1;
  VSLANG_FRENCH = 2;
  VSLANG_GERMAN = 3;
  VSLANG_SPANISH = 4;
  VSLANG_PORTUGUESE = 5;
  VSLANG_ITALIAN = 6;
  VSLANG_DUTCH = 7;
  VSLANG_SWEDISH = 8;
  VSLANG_FINNISH = 9;
  VSLANG_NORWEGIAN = 10;
  VSLANG_LATIN = 11;
  VSLANG_WELSH = 12;
  VSLANG_POLISH = 13;
  VSLANG_HUNGARIAN = 14;
  VSLANG_FLEMISH = 15;
  VSLANG_CZECH = 16;
  VSLANG_ICELANDIC = 17;
  VSLANG_ESPERANTO = 18;
  VSLANG_CATALAN = 19;
  VSLANG_ROMANIAN = 20;
  VSLANG_BULGARIAN = 21;
  VSLANG_RUSSIAN = 22;
  VSLANG_QUECHUA = 23;
  VSLANG_TURKISH = 24;
  VSLANG_INDONESIAN = 25;
  VSLANG_HEBREW = 26;
  VSLANG_DANISH = 27;
  VSLANG_CANADIAN = 28;

{ EventOptionBits }

  VSEVOPT_COMPLETE = 1;
  VSEVOPT_FOUND = 2;
  VSEVOPT_MISSPELLED = 4;
  VSEVOPT_BEFORE_REPLACE = 8;
  VSEVOPT_AFTER_POPUP = 16;
  VSEVOPT_CHECK_STATUS = 32;
  VSEVOPT_CHECK_ERROR = 64;
  VSEVOPT_AFTER_REPLACE = 128;
  VSEVOPT_CLICK_IN = 256;
  VSEVOPT_CLICK_OUT = 512;
  VSEVOPT_DEFAULTS = 65533;

{ SearchOrderCodes }

  VSORDER_SCIR = 0;
  VSORDER_CIRS = 2;
  VSORDER_IRSC = 3;
  VSORDER_SIRC = 4;
  VSORDER_CSIR = 6;
  VSORDER_IRCS = 7;
  VSORDER_NO_LOOKAHEAD = 8;

{ SpellOptionBits }

  VSOPT_AUTO_REPLACE = 1;
  VSOPT_AUTO_SUGGEST = 2;
  VSOPT_AUTO_POPUP = 4;
  VSOPT_IGNORE_FULL_CAPS = 8;
  VSOPT_IGNORE_PARTIAL_NUMBERS = 16;
  VSOPT_MULTILINE = 32;
  VSOPT_IGNORE_PURE_NUMBERS = 64;
  VSOPT_ALLOW_JOINED_WORDS = 128;
  VSOPT_EXACT_MATCH = 256;
  VSOPT_RETURN_EACH_WORD = 512;
  VSOPT_REPLACE_RECHECK = 1024;
  VSOPT_DEFAULTS = 1127;

{ SuggestOptionBits }

  VSSUGOPT_CAPITALIZATION = 1;
  VSSUGOPT_CHARSWAP = 2;
  VSSUGOPT_DELETES = 4;
  VSSUGOPT_DOUBLES = 8;
  VSSUGOPT_HYPHENS = 16;
  VSSUGOPT_SPLITS = 32;
  VSSUGOPT_EXCHANGES = 64;
  VSSUGOPT_INSERTIONS = 512;
  VSSUGOPT_DEFAULTS = 639;

{ IgnoreReplaceCodes }

  VSIR_GLOBAL = 1;
  VSIR_PROMPT = 2;
  VSIR_IGNORE = 4;
  VSIR_REPLACE = 8;
  VSIR_HYPHENATION = 16;
  VSIR_SPELLED_OK = 5;
  VSIR_REPLACE_ALL = 9;
  VSIR_MISSPELLED = 6;
  VSIR_PROMPT_REPLACE = 10;

{ EventActionCodes }

  VS_DEFAULT_HANDLING = 0;
  VS_EVENT_HANDLED = 1;
  VS_CANCEL_SPELLCHECK = 2;

{ ButtonClickBits }

  VSCLICK_WORD_MISSPELLED_HELP = 1;
  VSCLICK_OPTIONS = 2;
  VSCLICK_PROMPT_REPLACE = 4;
  VSCLICK_ADD_TO_CUSTOM = 8;
  VSCLICK_REPLACE_ALL = 16;
  VSCLICK_REPLACE = 32;
  VSCLICK_IGNORE_ALL = 64;
  VSCLICK_IGNORE = 128;
  VSCLICK_SUGGEST_NOT_FOUND = 256;
  VSCLICK_SUGGEST_REPLACE_WITH = 512;
  VSCLICK_CANCEL_SPELLCHECK = 1024;
  VSCLICK_THESAURUS = 2048;
  VSCLICK_OPTIONS_HELP = 65536;
  VSCLICK_OPTIONS_OK = 131072;
  VSCLICK_OPTIONS_CANCEL = 262144;
  VSCLICK_OPEN_CUSTOM = 524288;
  VSCLICK_CLOSE_CUSTOM = 1048576;
  VSCLICK_OPEN_STANDARD = 2097152;
  VSCLICK_CLOSE_STANDARD = 4194304;
  VSCLICK_THESAURUS_OK = 16777216;
  VSCLICK_THESAURUS_SEARCH = 33554432;
  VSCLICK_THESAURUS_CANCEL = 67108864;
  VSCLICK_THESAURUS_HELP = 134217728;

{ DialogElementBits }

  VSD_WORD_MISSPELLED_HELP = 1;
  VSD_OPTIONS = 2;
  VSD_PROMPT_REPLACE = 4;
  VSD_ADD_TO_CUSTOM = 8;
  VSD_REPLACE_ALL = 16;
  VSD_REPLACE = 32;
  VSD_IGNORE_ALL = 64;
  VSD_IGNORE = 128;
  VSD_SUGGEST_NOT_FOUND = 256;
  VSD_SUGGEST_REPLACE_WITH = 512;
  VSD_CANCEL_SPELLCHECK = 1024;
  VSD_SUGGESTIONS_LIST = 2048;
  VSD_REPLACE_BOX = 4096;
  VSD_CUSTOM_LIST = 8192;
  VSD_THESAURUS = 16384;
  VSD_OPTIONS_HELP = 65536;
  VSD_CUSTOMS = 131072;
  VSD_STANDARDS = 262144;
  VSD_PERFORMANCE = 524288;
  VSD_SUGGESTION_LIMIT = 1048576;
  VSD_AUTO_SUGGESTIONS = 2097152;
  VSD_EXACT_MATCH = 4194304;
  VSD_IGNORE_FULL_CAPS = 8388608;
  VSD_IGNORE_PARTIAL = 16777216;
  VSD_IGNORE_PURE = 33554432;
  VSD_ALLOW_JOINED = 67108864;
  VSD_RECHECK = 134217728;
  VSD_THESAURUS_HELP = 268435456;
  VSD_THESAURUS_SEARCH = 536870912;

{ ResultStatusCodes }

  VSR_WORD_MISSPELLED = -1;
  VSR_IGNORE_REPLACE = -2;
  VSR_CHECK_CANCELED = -3;
  VSR_BREAK = -4;
  VSR_FOUND = -5;
  VSR_REPLACED = -6;
  VSR_CHANGED = -7;
  VSR_END_LIST = -8;
  VSR_ENTRY_NOT_FOUND = -9;
  VSR_OPENED_READONLY = -11;
  VSR_REPLACE_OVERFLOW = -12;
  VSR_NOT_ADDED = -13;
  VSR_POPPED = -14;
  VSR_CLICK_IN = -15;
  VSR_CLICK_OUT = -16;

{ ResultErrorCodes }

  VSR_NO_ERROR = 0;
  VSR_WORD_TOO_LONG = 1;
  VSR_NO_MISSPELL = 2;
  VSR_ALREADY_OPEN = 4;
  VSR_OPEN_FAILED = 5;
  VSR_CREATE_FAILED = 6;
  VSR_INVALID_DICTIONARY = 7;
  VSR_WRITE_FAILURE = 9;
  VSR_READ_FAILURE = 10;
  VSR_BAD_FILE_NAME = 11;
  VSR_NOT_UPDATEABLE = 12;
  VSR_DUPLICATE_WORD = 13;
  VSR_BAD_CUSTOM = 14;
  VSR_IN_EVENT = 15;
  VSR_NOT_LOADED = 16;
  VSR_REPLACE_ERROR = 17;
  VSR_CACHE_ERROR = 18;
  VSR_INVALID_CONTEXT = 19;
  VSR_NOTHING_TO_CHECK = 20;
  VSR_DIALOG_ERROR = 21;
  VSR_OUT_OF_MEMORY = 22;
  VSR_BAD_INDEX = 23;
  VSR_OUT_OF_STRING_SPACE = 24;
  VSR_IN_DIALOG = 25;
  VSR_FILE_EXISTS = 26;

{ RuntimeErrorCodes }

  VB_OFFSET = 32350;
  VBR_WORD_TOO_LONG = 32351;
  VBR_NO_MISSPELL = 32352;
  VBR_ALREADY_OPEN = 32354;
  VBR_OPEN_FAILED = 32355;
  VBR_CREATE_FAILED = 32356;
  VBR_INVALID_DICTIONARY = 32357;
  VBR_WRITE_FAILURE = 32359;
  VBR_READ_FAILURE = 32360;
  VBR_BAD_FILE_NAME = 32361;
  VBR_NOT_UPDATEABLE = 32362;
  VBR_DUPLICATE_WORD = 32363;
  VBR_BAD_CUSTOM = 32364;
  VBR_IN_EVENT = 32365;
  VBR_NOT_LOADED = 32366;
  VBR_REPLACE_ERROR = 32367;
  VBR_CACHE_ERROR = 32368;
  VBR_INVALID_CONTEXT = 32369;
  VBR_NOTHING_TO_CHECK = 32370;
  VBR_DIALOG_ERROR = 32371;
  VBR_OUT_OF_MEMORY = 32372;
  VBR_BAD_INDEX = 32373;
  VBR_OUT_OF_STRING_SPACE = 32374;
  VBR_IN_DIALOG = 32375;
  VBR_FILE_EXISTS = 32376;

{ MiscellaneousCodes }

  VS_ALL = 0;
  VS_MAXWORDSIZE = 75;

type

  TVCSpellerMisspelled = procedure(Sender: TObject; var EventAction: Smallint) of object;
  TVCSpellerComplete = procedure(Sender: TObject; var EventAction: Smallint) of object;
  TVCSpellerFound = procedure(Sender: TObject; var EventAction: Smallint) of object;
  TVCSpellerBeforeReplace = procedure(Sender: TObject; var EventAction: Smallint) of object;
  TVCSpellerAfterReplace = procedure(Sender: TObject; var EventAction: Smallint) of object;
  TVCSpellerAfterPopup = procedure(Sender: TObject; var EventAction: Smallint) of object;
  TVCSpellerCheckStatus = procedure(Sender: TObject; var EventAction: Smallint) of object;
  TVCSpellerCheckError = procedure(Sender: TObject; var EventAction: Smallint) of object;
  TVCSpellerClickIn = procedure(Sender: TObject; var EventAction: Smallint) of object;
  TVCSpellerClickOut = procedure(Sender: TObject; var EventAction: Smallint) of object;

  TVCSpeller = class(TOleControl)
  private
    FOnMisspelled: TVCSpellerMisspelled;
    FOnComplete: TVCSpellerComplete;
    FOnFound: TVCSpellerFound;
    FOnBeforeReplace: TVCSpellerBeforeReplace;
    FOnAfterReplace: TVCSpellerAfterReplace;
    FOnAfterPopup: TVCSpellerAfterPopup;
    FOnCheckStatus: TVCSpellerCheckStatus;
    FOnCheckError: TVCSpellerCheckError;
    FOnClickIn: TVCSpellerClickIn;
    FOnClickOut: TVCSpellerClickOut;
    procedure Set_OpenStandard(loadit: TOleBool; const Value: string); stdcall;
    function Get_DictionaryLanguage(index: Smallint): Smallint; stdcall;
    function Get_DictionaryName(index: Smallint): string; stdcall;
    function Get_DictionaryStatus(index: Smallint): Smallint; stdcall;
    function Get_DictionaryIsEnabled(index: Smallint): TOleBool; stdcall;
    function Get_DictionaryNameFull(index: Smallint): string; stdcall;
    function Get_StandardIRListIsEnabled(index: Smallint): TOleBool; stdcall;
    function Get_DictionaryIsLoaded(index: Smallint): TOleBool; stdcall;
    function Get_DictionaryPerformance(index: Smallint): Smallint; stdcall;
    procedure Set_DictionaryPerformance(index: Smallint; Value: Smallint); stdcall;
    function Get_Suggestion(index: Smallint): string; stdcall;
    function Get_CustomIsUpdateable(index: Smallint): TOleBool; stdcall;
    procedure Set_AddToStandardIRList(index: Smallint; Value: Smallint); stdcall;
    procedure Set_AddSuggestion(matchcode: Smallint; const Value: string); stdcall;
    procedure Set_AddToCustom(index: Smallint; Value: Smallint); stdcall;
    procedure Set_ClearStandardIRList(index: Smallint; Value: Smallint); stdcall;
    procedure Set_CloseDictionary(index: Smallint; Value: Smallint); stdcall;
    procedure Set_GetEntry(index: Smallint; Value: Integer); stdcall;
    procedure Set_RemoveFromStandardIRList(index: Smallint; const Value: string); stdcall;
    function Get_DictionaryPerformanceActual(index: Smallint): Smallint; stdcall;
    function Get_DictionaryBlockCount(index: Smallint): Smallint; stdcall;
    function Get_DictionaryBlockSize(index: Smallint): Smallint; stdcall;
    function Get_DictionaryCommonCount(index: Smallint): Smallint; stdcall;
    function Get_DictionaryCompatibilityBits(index: Smallint): Smallint; stdcall;
    function Get_DictionaryCopyright(index: Smallint): string; stdcall;
    function Get_DictionaryCopyrightDerived(index: Smallint): string; stdcall;
    function Get_DictionaryFlags(index: Smallint): Smallint; stdcall;
    function Get_DictionaryLoadCount(index: Smallint): Smallint; stdcall;
    function Get_DictionaryMakerVersion(index: Smallint): Smallint; stdcall;
    function Get_DictionaryOpenCount(index: Smallint): Smallint; stdcall;
    function Get_DictionarySymbolSetSize(index: Smallint): Smallint; stdcall;
    function Get_DictionaryWordCount(index: Smallint): Integer; stdcall;
    procedure Set_CreateCustomExtended(index: Smallint; const Value: string); stdcall;
    procedure Set_EnableDictionary(index: Smallint; Value: TOleBool); stdcall;
    procedure Set_EnableCustomUpdate(index: Smallint; Value: TOleBool); stdcall;
    procedure Set_LoadDictionary(index: Smallint; Value: Smallint); stdcall;
    procedure Set_UnloadDictionary(index: Smallint; Value: Smallint); stdcall;
    function Get_CustomIsReadOnly(index: Smallint): TOleBool; stdcall;
    function Get_CustomIsExtended(index: Smallint): TOleBool; stdcall;
    procedure Set_EnableStandardIRList(index: Smallint; Value: TOleBool); stdcall;
    procedure Set_OpenCustom(loadit: TOleBool; const Value: string); stdcall;
  protected
    procedure InitControlData; override;
  public
    procedure AboutBox; stdcall;
    property OpenStandard[loadit: TOleBool]: string write Set_OpenStandard;
    property DictionaryLanguage[index: Smallint]: Smallint read Get_DictionaryLanguage;
    property DictionaryName[index: Smallint]: string read Get_DictionaryName;
    property DictionaryStatus[index: Smallint]: Smallint read Get_DictionaryStatus;
    property DictionaryIsEnabled[index: Smallint]: TOleBool read Get_DictionaryIsEnabled;
    property DictionaryNameFull[index: Smallint]: string read Get_DictionaryNameFull;
    property StandardIRListIsEnabled[index: Smallint]: TOleBool read Get_StandardIRListIsEnabled;
    property DictionaryIsLoaded[index: Smallint]: TOleBool read Get_DictionaryIsLoaded;
    property DictionaryPerformance[index: Smallint]: Smallint read Get_DictionaryPerformance write Set_DictionaryPerformance;
    property Suggestion[index: Smallint]: string read Get_Suggestion;
    property CustomIsUpdateable[index: Smallint]: TOleBool read Get_CustomIsUpdateable;
    property AddToStandardIRList[index: Smallint]: Smallint write Set_AddToStandardIRList;
    property AddSuggestion[matchcode: Smallint]: string write Set_AddSuggestion;
    property AddToCustom[index: Smallint]: Smallint write Set_AddToCustom;
    property ClearStandardIRList[index: Smallint]: Smallint write Set_ClearStandardIRList;
    property CloseDictionary[index: Smallint]: Smallint write Set_CloseDictionary;
    property GetEntry[index: Smallint]: Integer write Set_GetEntry;
    property RemoveFromStandardIRList[index: Smallint]: string write Set_RemoveFromStandardIRList;
    property DictionaryPerformanceActual[index: Smallint]: Smallint read Get_DictionaryPerformanceActual;
    property DictionaryBlockCount[index: Smallint]: Smallint read Get_DictionaryBlockCount;
    property DictionaryBlockSize[index: Smallint]: Smallint read Get_DictionaryBlockSize;
    property DictionaryCommonCount[index: Smallint]: Smallint read Get_DictionaryCommonCount;
    property DictionaryCompatibilityBits[index: Smallint]: Smallint read Get_DictionaryCompatibilityBits;
    property DictionaryCopyright[index: Smallint]: string read Get_DictionaryCopyright;
    property DictionaryCopyrightDerived[index: Smallint]: string read Get_DictionaryCopyrightDerived;
    property DictionaryFlags[index: Smallint]: Smallint read Get_DictionaryFlags;
    property DictionaryLoadCount[index: Smallint]: Smallint read Get_DictionaryLoadCount;
    property DictionaryMakerVersion[index: Smallint]: Smallint read Get_DictionaryMakerVersion;
    property DictionaryOpenCount[index: Smallint]: Smallint read Get_DictionaryOpenCount;
    property DictionarySymbolSetSize[index: Smallint]: Smallint read Get_DictionarySymbolSetSize;
    property DictionaryWordCount[index: Smallint]: Integer read Get_DictionaryWordCount;
    property CreateCustomExtended[index: Smallint]: string write Set_CreateCustomExtended;
    property EnableDictionary[index: Smallint]: TOleBool write Set_EnableDictionary;
    property EnableCustomUpdate[index: Smallint]: TOleBool write Set_EnableCustomUpdate;
    property LoadDictionary[index: Smallint]: Smallint write Set_LoadDictionary;
    property UnloadDictionary[index: Smallint]: Smallint write Set_UnloadDictionary;
    property CustomIsReadOnly[index: Smallint]: TOleBool read Get_CustomIsReadOnly;
    property CustomIsExtended[index: Smallint]: TOleBool read Get_CustomIsExtended;
    property EnableStandardIRList[index: Smallint]: TOleBool write Set_EnableStandardIRList;
    property OpenCustom[loadit: TOleBool]: string write Set_OpenCustom;
  published
    property AutoPopup: TOleBool index 4 read GetOleBoolProp write SetOleBoolProp stored False;
    property AutoReplace: TOleBool index 5 read GetOleBoolProp write SetOleBoolProp stored False;
    property AutoSuggest: TOleBool index 6 read GetOleBoolProp write SetOleBoolProp stored False;
    property BreakWordCount: Smallint index 7 read GetSmallintProp write SetSmallintProp stored False;
    property CacheSize: Smallint index 8 read GetSmallintProp write SetSmallintProp stored False;
    property ErrorOffset: Smallint index 1 read GetSmallintProp write SetSmallintProp stored False;
    property IgnoreFullCaps: TOleBool index 9 read GetOleBoolProp write SetOleBoolProp stored False;
    property IgnorePartialNumbers: TOleBool index 10 read GetOleBoolProp write SetOleBoolProp stored False;
    property MaxSuggestions: Smallint index 11 read GetSmallintProp write SetSmallintProp stored False;
    property MultiLine: TOleBool index 12 read GetOleBoolProp write SetOleBoolProp stored False;
    property SuggestionsLimit: Smallint index 13 read GetSmallintProp write SetSmallintProp stored False;
    property Version: string index 14 read GetStringProp write SetStringProp stored False;
    property CurrentLine: Integer index 15 read GetIntegerProp write SetIntegerProp stored False;
    property CustomCount: Smallint index 16 read GetSmallintProp write SetSmallintProp stored False;
    property DLLHandle: Integer index 17 read GetIntegerProp write SetIntegerProp stored False;
    property EventOptions: Smallint index 18 read GetSmallintProp write SetSmallintProp stored False;
    property Hyphenation: string index 19 read GetStringProp write SetStringProp stored False;
    property IRAction: Smallint index 20 read GetSmallintProp write SetSmallintProp stored False;
    property IRWhereFound: Smallint index 21 read GetSmallintProp write SetSmallintProp stored False;
    property LineBreak: string index 22 read GetStringProp write SetStringProp stored False;
    property LineOffset: Smallint index 23 read GetSmallintProp write SetSmallintProp stored False;
    property MisspelledWord: string index 24 read GetStringProp write SetStringProp stored False;
    property ReplaceCount: Integer index 25 read GetIntegerProp write SetIntegerProp stored False;
    property ReplacementWord: string index 26 read GetStringProp write SetStringProp stored False;
    property ResultCode: Smallint index 27 read GetSmallintProp write SetSmallintProp stored False;
    property ResumeOffset: Integer index 28 read GetIntegerProp write SetIntegerProp stored False;
    property SearchOrder: Smallint index 29 read GetSmallintProp write SetSmallintProp stored False;
    property SpellOptions: Smallint index 30 read GetSmallintProp write SetSmallintProp stored False;
    property StandardCount: Smallint index 31 read GetSmallintProp write SetSmallintProp stored False;
    property SuggestOptions: Smallint index 32 read GetSmallintProp write SetSmallintProp stored False;
    property SuggestionCount: Smallint index 33 read GetSmallintProp write SetSmallintProp stored False;
    property Text: string index 34 read GetStringProp write SetStringProp stored False;
    property WhereFound: Smallint index 35 read GetSmallintProp write SetSmallintProp stored False;
    property WordCount: Integer index 36 read GetIntegerProp write SetIntegerProp stored False;
    property WordOffset: Integer index 37 read GetIntegerProp write SetIntegerProp stored False;
    property AllowJoinedWords: TOleBool index 38 read GetOleBoolProp write SetOleBoolProp stored False;
    property DialogLeft: Integer index 39 read GetIntegerProp write SetIntegerProp stored False;
    property DialogTop: Integer index 40 read GetIntegerProp write SetIntegerProp stored False;
    property ReplaceRecheck: TOleBool index 41 read GetOleBoolProp write SetOleBoolProp stored False;
    property DialogBgColor: TColor index 42 read GetColorProp write SetColorProp stored False;
    property DialogLeftActual: Integer index 43 read GetIntegerProp write SetIntegerProp stored False;
    property DialogTopActual: Integer index 44 read GetIntegerProp write SetIntegerProp stored False;
    property ReplaceOccurred: TOleBool index 45 read GetOleBoolProp write SetOleBoolProp stored False;
    property SuggestionsMade: TOleBool index 46 read GetOleBoolProp write SetOleBoolProp stored False;
    property WordLength: Smallint index 47 read GetSmallintProp write SetSmallintProp stored False;
    property CacheHits: Integer index 48 read GetIntegerProp write SetIntegerProp stored False;
    property CacheMisses: Integer index 49 read GetIntegerProp write SetIntegerProp stored False;
    property TimerTicks: Integer index 50 read GetIntegerProp write SetIntegerProp stored False;
    property UserData: Integer index 51 read GetIntegerProp write SetIntegerProp stored False;
    property CheckedWord: string index 52 read GetStringProp write SetStringProp stored False;
    property CommonIRListIsEnabled: TOleBool index 53 read GetOleBoolProp write SetOleBoolProp stored False;
    property WordMisspelledTitle: string index 54 read GetStringProp write SetStringProp stored False;
    property OptionsTitle: string index 55 read GetStringProp write SetStringProp stored False;
    property ErrorTitle: string index 56 read GetStringProp write SetStringProp stored False;
    property WordMisspelledHelpFile: string index 57 read GetStringProp write SetStringProp stored False;
    property OptionsHelpFile: string index 58 read GetStringProp write SetStringProp stored False;
    property DialogElements: Integer index 59 read GetIntegerProp write SetIntegerProp stored False;
    property DialogWidth: Integer index 60 read GetIntegerProp write SetIntegerProp stored False;
    property DialogHeight: Integer index 61 read GetIntegerProp write SetIntegerProp stored False;
    property ErrorText: string index 62 read GetStringProp write SetStringProp stored False;
    property ClickedButton: Integer index 63 read GetIntegerProp write SetIntegerProp stored False;
    property ClickInfo: Integer index 64 read GetIntegerProp write SetIntegerProp stored False;
    property ClickInfoText: string index 65 read GetStringProp write SetStringProp stored False;
    property AddToCommonIRList: Smallint index 66 read GetSmallintProp write SetSmallintProp stored False;
    property BeginCheck: Smallint index 67 read GetSmallintProp write SetSmallintProp stored False;
    property CheckText: string index 68 read GetStringProp write SetStringProp stored False;
    property CheckWord: string index 69 read GetStringProp write SetStringProp stored False;
    property ClearCounts: Smallint index 70 read GetSmallintProp write SetSmallintProp stored False;
    property ClearOffsets: Smallint index 71 read GetSmallintProp write SetSmallintProp stored False;
    property FindSuggestions: string index 72 read GetStringProp write SetStringProp stored False;
    property ReplaceLastWord: Smallint index 73 read GetSmallintProp write SetSmallintProp stored False;
    property ResumeCheck: Smallint index 74 read GetSmallintProp write SetSmallintProp stored False;
    property ClearSuggestions: Smallint index 75 read GetSmallintProp write SetSmallintProp stored False;
    property PopupError: Smallint index 76 read GetSmallintProp write SetSmallintProp stored False;
    property PopupOptions: Smallint index 77 read GetSmallintProp write SetSmallintProp stored False;
    property PopupWordMisspelled: Smallint index 78 read GetSmallintProp write SetSmallintProp stored False;
    property CreateCustom: string index 79 read GetStringProp write SetStringProp stored False;
    property ResumeWithRecheck: Smallint index 80 read GetSmallintProp write SetSmallintProp stored False;
    property EnableCommonIRList: TOleBool index 81 read GetOleBoolProp write SetOleBoolProp stored False;
    property ClearCommonIRList: Smallint index 82 read GetSmallintProp write SetSmallintProp stored False;
    property RemoveFromCommonIRList: string index 83 read GetStringProp write SetStringProp stored False;
    property EnableEventOptions: Smallint index 84 read GetSmallintProp write SetSmallintProp stored False;
    property DisableEventOptions: Smallint index 85 read GetSmallintProp write SetSmallintProp stored False;
    property EnableSpellOptions: Smallint index 86 read GetSmallintProp write SetSmallintProp stored False;
    property DisableSpellOptions: Smallint index 87 read GetSmallintProp write SetSmallintProp stored False;
    property EnableSuggestOptions: Smallint index 88 read GetSmallintProp write SetSmallintProp stored False;
    property DisableSuggestOptions: Smallint index 89 read GetSmallintProp write SetSmallintProp stored False;
    property EnableDialogElements: Integer index 90 read GetIntegerProp write SetIntegerProp stored False;
    property DisableDialogElements: Integer index 91 read GetIntegerProp write SetIntegerProp stored False;
    property StandardDictionary: string index 2 read GetStringProp write SetStringProp stored False;
    property CustomDictionary: string index 3 read GetStringProp write SetStringProp stored False;
    property OnMisspelled: TVCSpellerMisspelled read FOnMisspelled write FOnMisspelled;
    property OnComplete: TVCSpellerComplete read FOnComplete write FOnComplete;
    property OnFound: TVCSpellerFound read FOnFound write FOnFound;
    property OnBeforeReplace: TVCSpellerBeforeReplace read FOnBeforeReplace write FOnBeforeReplace;
    property OnAfterReplace: TVCSpellerAfterReplace read FOnAfterReplace write FOnAfterReplace;
    property OnAfterPopup: TVCSpellerAfterPopup read FOnAfterPopup write FOnAfterPopup;
    property OnCheckStatus: TVCSpellerCheckStatus read FOnCheckStatus write FOnCheckStatus;
    property OnCheckError: TVCSpellerCheckError read FOnCheckError write FOnCheckError;
    property OnClickIn: TVCSpellerClickIn read FOnClickIn write FOnClickIn;
    property OnClickOut: TVCSpellerClickOut read FOnClickOut write FOnClickOut;
  end;

procedure Register;

implementation

{$J+}

procedure TVCSpeller.InitControlData;
const
  CEventDispIDs: array[0..9] of Integer = (
    $00000001, $00000002, $00000003, $00000004, $00000005, $00000006,
    $00000007, $00000008, $00000009, $0000000A);
  CLicenseKey: array[0..19] of Word = (
    $0043, $006F, $0070, $0079, $0072, $0069, $0067, $0068, $0074, $0020,
    $0028, $0063, $0029, $0020, $0031, $0039, $0039, $0035, $0020, $0000);
  CControlData: TControlData = (
    ClassID: (
      D1:$97F4CED0;D2:$9103;D3:$11CE;D4:($83,$85,$52,$41,$53,$48,$00,$01));
    EventIID: (
      D1:$97F4CED2;D2:$9103;D3:$11CE;D4:($83,$85,$52,$41,$53,$48,$00,$01));
    EventCount: 10;
    EventDispIDs: @CEventDispIDs;
    LicenseKey: @CLicenseKey;
    Flags: $00000000);
begin
  ControlData := @CControlData;
end;

procedure TVCSpeller.AboutBox;
const
  DispInfo: array[0..7] of Byte = ($D8,$FD,$FF,$FF,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCSpeller.Set_OpenStandard;
const
  DispInfo: array[0..9] of Byte = ($5C,$00,$00,$00,$00,$04,$02,$00,$0B,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCSpeller.Get_DictionaryLanguage;
const
  DispInfo: array[0..8] of Byte = ($6B,$00,$00,$00,$02,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCSpeller.Get_DictionaryName;
const
  DispInfo: array[0..8] of Byte = ($6C,$00,$00,$00,$08,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCSpeller.Get_DictionaryStatus;
const
  DispInfo: array[0..8] of Byte = ($6D,$00,$00,$00,$02,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCSpeller.Get_DictionaryIsEnabled;
const
  DispInfo: array[0..8] of Byte = ($6E,$00,$00,$00,$0B,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCSpeller.Get_DictionaryNameFull;
const
  DispInfo: array[0..8] of Byte = ($6F,$00,$00,$00,$08,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCSpeller.Get_StandardIRListIsEnabled;
const
  DispInfo: array[0..8] of Byte = ($70,$00,$00,$00,$0B,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCSpeller.Get_DictionaryIsLoaded;
const
  DispInfo: array[0..8] of Byte = ($71,$00,$00,$00,$0B,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCSpeller.Get_DictionaryPerformance;
const
  DispInfo: array[0..8] of Byte = ($72,$00,$00,$00,$02,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCSpeller.Set_DictionaryPerformance;
const
  DispInfo: array[0..9] of Byte = ($72,$00,$00,$00,$00,$04,$02,$00,$02,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCSpeller.Get_Suggestion;
const
  DispInfo: array[0..8] of Byte = ($73,$00,$00,$00,$08,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCSpeller.Get_CustomIsUpdateable;
const
  DispInfo: array[0..8] of Byte = ($74,$00,$00,$00,$0B,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCSpeller.Set_AddToStandardIRList;
const
  DispInfo: array[0..9] of Byte = ($5D,$00,$00,$00,$00,$04,$02,$00,$02,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCSpeller.Set_AddSuggestion;
const
  DispInfo: array[0..9] of Byte = ($5E,$00,$00,$00,$00,$04,$02,$00,$02,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCSpeller.Set_AddToCustom;
const
  DispInfo: array[0..9] of Byte = ($5F,$00,$00,$00,$00,$04,$02,$00,$02,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCSpeller.Set_ClearStandardIRList;
const
  DispInfo: array[0..9] of Byte = ($60,$00,$00,$00,$00,$04,$02,$00,$02,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCSpeller.Set_CloseDictionary;
const
  DispInfo: array[0..9] of Byte = ($61,$00,$00,$00,$00,$04,$02,$00,$02,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCSpeller.Set_GetEntry;
const
  DispInfo: array[0..9] of Byte = ($62,$00,$00,$00,$00,$04,$02,$00,$02,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCSpeller.Set_RemoveFromStandardIRList;
const
  DispInfo: array[0..9] of Byte = ($63,$00,$00,$00,$00,$04,$02,$00,$02,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCSpeller.Get_DictionaryPerformanceActual;
const
  DispInfo: array[0..8] of Byte = ($75,$00,$00,$00,$02,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCSpeller.Get_DictionaryBlockCount;
const
  DispInfo: array[0..8] of Byte = ($76,$00,$00,$00,$02,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCSpeller.Get_DictionaryBlockSize;
const
  DispInfo: array[0..8] of Byte = ($77,$00,$00,$00,$02,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCSpeller.Get_DictionaryCommonCount;
const
  DispInfo: array[0..8] of Byte = ($78,$00,$00,$00,$02,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCSpeller.Get_DictionaryCompatibilityBits;
const
  DispInfo: array[0..8] of Byte = ($79,$00,$00,$00,$02,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCSpeller.Get_DictionaryCopyright;
const
  DispInfo: array[0..8] of Byte = ($7A,$00,$00,$00,$08,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCSpeller.Get_DictionaryCopyrightDerived;
const
  DispInfo: array[0..8] of Byte = ($7B,$00,$00,$00,$08,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCSpeller.Get_DictionaryFlags;
const
  DispInfo: array[0..8] of Byte = ($7C,$00,$00,$00,$02,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCSpeller.Get_DictionaryLoadCount;
const
  DispInfo: array[0..8] of Byte = ($7D,$00,$00,$00,$02,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCSpeller.Get_DictionaryMakerVersion;
const
  DispInfo: array[0..8] of Byte = ($7E,$00,$00,$00,$02,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCSpeller.Get_DictionaryOpenCount;
const
  DispInfo: array[0..8] of Byte = ($7F,$00,$00,$00,$02,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCSpeller.Get_DictionarySymbolSetSize;
const
  DispInfo: array[0..8] of Byte = ($80,$00,$00,$00,$02,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCSpeller.Get_DictionaryWordCount;
const
  DispInfo: array[0..8] of Byte = ($81,$00,$00,$00,$03,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCSpeller.Set_CreateCustomExtended;
const
  DispInfo: array[0..9] of Byte = ($64,$00,$00,$00,$00,$04,$02,$00,$02,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCSpeller.Set_EnableDictionary;
const
  DispInfo: array[0..9] of Byte = ($65,$00,$00,$00,$00,$04,$02,$00,$02,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCSpeller.Set_EnableCustomUpdate;
const
  DispInfo: array[0..9] of Byte = ($66,$00,$00,$00,$00,$04,$02,$00,$02,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCSpeller.Set_LoadDictionary;
const
  DispInfo: array[0..9] of Byte = ($67,$00,$00,$00,$00,$04,$02,$00,$02,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCSpeller.Set_UnloadDictionary;
const
  DispInfo: array[0..9] of Byte = ($68,$00,$00,$00,$00,$04,$02,$00,$02,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCSpeller.Get_CustomIsReadOnly;
const
  DispInfo: array[0..8] of Byte = ($82,$00,$00,$00,$0B,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TVCSpeller.Get_CustomIsExtended;
const
  DispInfo: array[0..8] of Byte = ($83,$00,$00,$00,$0B,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TVCSpeller.Set_EnableStandardIRList;
const
  DispInfo: array[0..9] of Byte = ($69,$00,$00,$00,$00,$04,$02,$00,$02,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCSpeller.Set_OpenCustom;
const
  DispInfo: array[0..9] of Byte = ($6A,$00,$00,$00,$00,$04,$02,$00,$0B,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure Register;
begin
  RegisterComponents('OCX', [TVCSpeller]);
end;

end.
